/**
* user:  A1001
* fname: Aleksandar
* lname: Krastev
* task:  crypto
* score: 20.0
* date:  2017-11-25 10:52:24.488689
*/
#include <iostream>
#include <cstdint>

const uint32_t MAX_N = 401;
const uint32_t MAX_P = MAX_N * (MAX_N - 1) / 2;
//const uint32_t MAX_P = 10;
const uint32_t MOD = 1e9 + 7;

uint32_t n, k, p;

uint32_t dp[MAX_P][MAX_N];
//TODO
uint32_t dpSum[MAX_P][MAX_N];

uint64_t fact(uint32_t a) {
	return a == 0 ? 1 : a * fact(a - 1) % MOD;
}

void calc_dp() {
	/*for (uint32_t i = 0;i <= k;i++) {
		for (uint32_t j = 0;j < MAX_P;j++) {
			dp[i][j] = 0;
		}
	}*/
	dp[0][k] = fact(k);
	for (uint32_t i = k + 1;i <= n;i++) {
		for (uint32_t j = 0;j < MAX_P;j++) {
			for (uint32_t p = 0;p < i;p++) {
				uint32_t cur = std::min(std::min(p, i - p - 1), k - 1);
				//std::cerr << i << " " << p << " " << cur << "\n";
				if (j + cur < MAX_P) {
					dp[j + cur][i] += dp[j][i - 1];
					if (dp[j + cur][i] >= MOD) {
						dp[j + cur][i] -= MOD;
					}
				}
			}
		}
	}
}


int main() {
	std::cin >> n >> k >> p;
	if (p > n * (n - 1) / 2) {
		std::cout << "0\n";
		return 0;
	}
	calc_dp();
	uint32_t base = n - k + 1;
	//std::cerr << p - base << "\n";
	std::cout << dp[p - base][n];
}
