/**
* user:  A1001
* fname: Aleksandar
* lname: Krastev
* task:  crypto
* score: 25.0
* date:  2017-11-25 12:07:33.498910
*/
#include <iostream>
#include <cstdint>

const uint32_t MAX_N = 401;
//const uint32_t MAX_P = MAX_N * (MAX_N - 1) / 2;
const uint32_t MAX_P = 30;
const uint32_t MOD = 1e9 + 7;

uint32_t n, k, p;

uint32_t dp[MAX_P][MAX_N];
//TODO
uint32_t dpSum[MAX_P][MAX_N];
uint32_t sum_query(uint32_t n, uint32_t p1, uint32_t p2) {
	if (p2 >= MAX_P) {
		p2 = MAX_P;
	}
	uint32_t ans = dpSum[p2][n];
	if (p2 < p1) {
		return 0;
	}

	if (p1 > 0) {
		ans = ans + MOD - dpSum[p1 - 1][n];
		while (ans >= MOD) {
			ans -= MOD;
		}
	}
	return ans;
}

uint64_t fact(uint32_t a) {
	return a == 0 ? 1 : a * fact(a - 1) % MOD;
}

void calc_dp() {
	/*for (uint32_t i = 0;i <= k;i++) {
		for (uint32_t j = 0;j < MAX_P;j++) {
			dp[i][j] = 0;
		}
	}*/
	dp[0][k] = fact(k);

	dpSum[0][k] = dp[0][k];
	for (uint32_t j = 1;j < MAX_P;j++) {
		dpSum[j][k] = dp[j][k] + dpSum[j - 1][k];
		if (dpSum[j][k] >= MOD) {
			dpSum[j][k] -= MOD;
		}
	}

	int32_t e1 = (k + 1) / 2 - 1;
	int32_t s3 = e1 + 1;
	for (uint32_t i = k + 1;i <= n;i++) {
		if ((e1 + 1 < i - e1 - 1) && (e1 + 1 < (int32_t)(k) - 1)) {
			e1++;
		}
		if ((i - s3 - 1 >= k - 1) || (s3 == e1)) {
			s3++;
		}
		
		for (uint32_t j = 0;j < MAX_P;j++) {
			uint32_t dps = 0;
			//e1 = j - e1;

			int32_t y1 = std::max((int32_t)(j) - e1, 0);
			int32_t y2 = std::max((int32_t)(j) + s3 + 1 - (int32_t)(i), 0);

			dps = sum_query(i - 1, y1, j);
			dps += sum_query(i - 1, y2, j);
			if (dps >= MOD) {
				dps -= MOD;
			}
			if ((s3 > e1 + 1) && (j + 1 >= k)) {
				dps += (s3 - e1 - 1) * (uint64_t) (dp[j - k + 1][i - 1]) % MOD;
				//std::cout << i - 1 << " " << j - k + 1 << "mid\n";
				if (dps >= MOD) {
					dps -= MOD;
				}
			}
			dp[j][i] = dps;

//			for (uint32_t p = 0;p < i;p++) {
//				uint32_t cur = std::min(std::min(p, i - p - 1), k - 1);
//				if (j == 0) {
//					std::cout << cur << " ";
//				}
//				//std::cerr << i << " " << p << " " << cur << "\n";
//				if (j >= cur) {
//					dp[j][i] += dp[j - cur][i - 1];
//					if (dp[j][i] >= MOD) {
//						dp[j][i] -= MOD;
//					}
//				}
//			}
//			if (j == 0) {
//				std::cout << "\n";
//				std::cout << e1 << " " << s3 << "\n";
//			}
//			if (dp[j][i] != dps) {
//				std::cout << "shit\n";
//				std::cout << j << " " << i << " " << dp[j][i] << " " << dps << "\n";
//			}
		}

		dpSum[0][i] = dp[0][i];
		for (uint32_t j = 1;j < MAX_P;j++) {
			dpSum[j][i] = dp[j][i] + dpSum[j - 1][i];
			if (dpSum[j][i] >= MOD) {
				dpSum[j][i] -= MOD;
			}
		}
	}
}


int main() {
	std::cin >> n >> k >> p;
	if (p > n * (n - 1) / 2) {
		std::cout << "0\n";
		return 0;
	}
	calc_dp();
	uint32_t base = n - k + 1;
	if (base > p) {
		std::cout << "0\n";
		return 0;
	}
	//std::cerr << p - base << "\n";
	std::cout << dp[p - base][n];
}
