/**
* user:  A1004
* fname: Viktor
* lname: Terziev
* task:  crypto
* score: 10.0
* date:  2017-11-25 12:34:33.266698
*/
#include <iostream>
#include <algorithm>
using namespace std;
int n, k, p;
long long dp[/*N*/512][/*P*/50024], mod = 1000000007;
long long ds[/*N*/512][/*P*/50024];


long long fact ( int x ) {
    return x == 0 ? 1 : x*fact(x-1)%mod;
}
int getCnt ( int x, int l ) {
    int sInd = max( 0 , x-k+1 ), fInd = min( l+1, x+k );
    return fInd - sInd -k+1;
}
int cntC[512];

int main () {

    cin >> n >> k >> p;

    int maxx = 0;

    dp[k][1] = fact(k);

    for ( int i = k ; i <= n ; i ++ ) {

        for ( int s = 0 ; s <= n ; s ++ ) {
            cntC[s] = 0;
        }
        for ( int s = 0 ; s <= n ; s ++ ) {
            cntC[ getCnt(s,i) ] ++ ;
        }
        int cS2 = 0, cF2 = 0;

        for ( int s = 0 ; s <= n ; s ++ ) {
            if ( cntC[s] == 2 && cS2 == 0 ) { cS2 = s; }
            if(  cntC[s]!= 2 && cS2 != 0 && cF2 == 0 ) { cF2 = s; }
        }

        for ( int cp = 1 ; cp <= (n-k+1)*k; cp ++ ) {

            ds[i+1][cp+cS2] += dp[i][cp]*2;
            ds[i+1][cp+cS2] %= mod;
            ds[i+1][cp+cF2] -= dp[i][cp]*2;
            ds[i+1][cp+cF2] %= mod;

            dp[i+1][cp+cF2] += dp[i][cp]*cntC[cF2];

            dp[i+1][cp+cF2] %= mod ;


            /*
            for ( int s = 0 ; s <= n ; s ++ ) {
                dp[i+1][ cp + s] += dp[i][ cp ]*cntC[s];
            }

            for ( int s = 0; s <= i ; s ++ ) {
                dp[i+1][ cp+getCnt(s, i) ] += dp[i][cp];

                if ( dp[i+1][ cp+getCnt(s, i) ] >= mod ){
                    dp[i+1][ cp+getCnt(s, i) ] -= mod;
                }
            }
            */
        }
        long long add = 0;
        for ( int s = 0 ; s <= n ; s ++ ) {
            ds[i+1][s] %= mod;

            add += ds[i+1][s];
            add += 2*mod;
            add %= mod;

            dp[i+1][s] += add;
            if ( dp[i+1][s] >= mod ) { dp[i+1][s] -= mod; }
        }

    }
//    cout << maxx << "\n";
    if ( p > k*(n-k+1) ) {
        cout << 0 << "\n";
        return 0;
    }
    cout << dp[n][p] << "\n";

    return 0;
}

