/**
* user:  A1007
* fname: Ivan
* lname: Ganev
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 08:33:44.160003
*/
# include <cstdio>
# include <vector>

using namespace std;

const int MAX_N = 256;

int n;
int goal[2];
int a[MAX_N][MAX_N];
bool t[MAX_N][MAX_N];

int par[2][MAX_N];
int cnt[2];
int ans;

vector <pair <int, int>> ansv;

int root (int c, int x)
{
	return (!par[c][x]) ? x : par[c][x] = root (c, par[c][x]);
}

int main ()
{
	int i, j, rx[2], ry[2], c;
	scanf ("%d", &n);
	for (i = 1; i <= n; i ++)
		for (j = 1; j <= n; j ++)
		{
			scanf ("%d", &a[i][j]);
			if (i >= j)
				continue;
			c = a[i][j];
			rx[c] = root (c, i);
			ry[c] = root (c, j);
			///printf ("%d %d %d %d %d\n", c, i, j, rx[c], ry[c]);
			if (rx[c] != ry[c])
			{
				///printf ("-- %d %d\n", i, j);
				cnt[c] ++;
				par[c][rx[c]] = ry[c];
				t[i][j] = true;
			}
		}
	scanf ("%d%d", &goal[0], &goal[1]);
	for (i = 1; i <= n; i ++)
		for (j = i + 1; j <= n; j ++)
			if (!t[i][j])
			{
				c = a[i][j] ^ 1;
				rx[c] = root (c, i);
				ry[c] = root (c, j);
				///printf ("---- %d %d %d %d %d\n", c, i, j, rx[c], ry[c]);
				if (rx[c] != ry[c])
				{
					///printf ("%d %d\n", i, j);
					cnt[c] ++;
					par[c][rx[c]] = ry[c];
					ans ++;
					ansv.push_back ({i, j});
				}
			}
	if (!(cnt[0] == n - 1 && cnt[1] == n - 1))
		ans = -1;

	printf ("%d\n", ans);
	if (ans != -1)
		for (i = 0; i < (int) ansv.size (); i ++)
			printf ("%d %d\n", ansv[i].first, ansv[i].second);

	return 0;	
}

