/**
* user:  A1007
* fname: Ivan
* lname: Ganev
* task:  clubs
* score: 35.0
* date:  2017-11-25 12:10:02.843670
*/
# include <cstdio>
# include <vector>
# include <queue>
# include <algorithm>

using namespace std;

const int MAX_L = 19;


int n, k;
int lim;
vector <int> v[MAX_L];

bool go ()
{
	int lvl, l, r;
	priority_queue <pair <int, pair <int, int>>> pq;
	while (!pq.empty ())
		pq.pop ();
	///printf ("-------------- %d\n", lim);
	pq.push ({0, {n, 1}});
	while (!pq.empty ())
	{
		pair <int, pair <int, int>> crr = pq.top ();
		pq.pop ();
		lvl = -crr.first;
		l = crr.second.second;
		r = l + crr.second.first - 1;
		///printf ("%d %d %d\n", lvl, l, r);
		if (lvl == k)
			if (l < r)
				return false;
		int mid = (l + r) >> 1, i;
		for (i = r; i >= mid + 1 && v[lvl].size () < lim; i --)
			v[lvl].push_back (i);
		if (l < i)
			pq.push ({-(lvl + 1), {(i - l + 1), l}});
		if ((i + 1) <= r)
			pq.push ({-(lvl + 1), {(r - i), i + 1}});
	}
	return true;
}

int main ()
{
	int i, j, s, len = 0;
	scanf ("%d", &n);

	for (k = 1; (1 << k) < n; k ++);
	
	int l, r, mid;
	l = 0;
	r = n + 1;
	while (r - l > 1)
	{
		mid = (l + r) >> 1;
		lim = mid;
		if (go ())
			r = mid;
		else
			l = mid;
		for (i = 0; i <= k; i ++)
			v[i].clear ();
	}
	lim = r;
	go ();
	for (i = 0; i < 19; i ++)
		if (!v[i].size ())
			break;
		else
			if (len < v[i].size ())
				len = v[i].size ();
	k = i;
	printf ("%d %d\n", k, len);
	
	for (i = 0; i < k; i ++)
	{
		printf ("%d", (int) v[i].size ());
		for (j = 0; j < (int) v[i].size (); j ++)
			printf (" %d", v[i][j]);
		printf ("\n");
	}
	
	
	return 0;
}

