/**
* user:  A1008
* fname: Radostin
* lname: Chonev
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 10:36:31.914310
*/
#include<iostream>
#include<stdio.h>
#include<vector>
using namespace std ;

#define MAXN 257

int n ;
int a[ MAXN ][ MAXN ] ;
int b[ MAXN ][ MAXN ] ;

int fl1 , fl2 ;

int get_bits ( int x ) {
	int ret = 0 ;
	while ( x != 0 ) {
		x = (x&(x-1)) ;
		ret ++ ;
	}
	return ret ;
}

int used[ MAXN ] ;


void dfs ( int vertex , int sr ) {
	int i ;
	used[ vertex ] = 1 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		if ( used[ i ] == 0 ) { 
			if ( b[ vertex ][ i ] == sr ) {
				dfs ( i , sr ) ;
			}
		}
	}
}

bool check ( int mask ) {
	int h = 1 ;
	int i , j ;
	for ( i = 1 ; i <= n ; i ++ ) {
		for ( j = 1 ; j <= n ; j ++ ) {
			b[ i ][ j ] = a[ i ][ j ] ;
		}
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		for ( j = ( i + 1 ) ; j <= n ; j ++ ) {
			if ( (mask&h) != 0 ) { b[ i ][ j ] ^= 1 ; b[ j ][ i ] ^= 1 ; }
			h *= 2 ;
		}
	}
	for ( i = 1 ; i <= n ; i ++ ) {
		used[ i ] = 0 ;
	}
	dfs ( 1 , 0 ) ;
	int p = 0 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		p += used[ i ] ;
	}
	if ( p == n && fl1 == 0 ) { return false ; }
	if ( p != n && fl1 == 1 ) { return false ; }
	for ( i = 1 ; i <= n ; i ++ ) {
		used[ i ] = 0 ;
	}
	dfs ( 1 , 1 ) ;
	p = 0 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		p += used[ i ] ;
	}
	if ( p == n && fl2 == 0 ) { return false ; }
	if ( p != n && fl2 == 1 ) { return false ; }
	return true ;
}

void input ( ) {
	scanf ( "%d" , &n ) ;
	int i , j ;
	for ( i = 1 ; i <= n ; i ++ ) {
		for ( j = 1 ; j <= n ; j ++ ) {
			scanf ( "%d" , &a[ i ][ j ] ) ;
		}
	}
	scanf ( "%d%d" , &fl1 , &fl2 ) ;
}

void solve ( ) {
	int cnt = ( n * ( n - 1 ) ) / 2 ;
	int mask = 0 ;
	int lim = (1<<cnt) ;
	int brbits = 720 ;
	int id = 0 ;
	for ( mask = 0 ; mask < lim ; mask ++ ) {
		if ( check ( mask ) == true ) {
			int w = get_bits ( mask ) ;
			if ( brbits > w ) {
				brbits = w ;
				id = mask ;
			}
		}
	}
	if ( brbits == 720 ) { printf ( "-1\n" ) ; return ; }
	printf ( "%d\n" , brbits ) ;
	int i , j ;
	int h = 1 ;
	for ( i = 1 ; i <= n ; i ++ ) {
		for ( j = ( i + 1 ) ; j <= n ; j ++ ) {
			if ( (id&h) != 0 ) { printf ( "%d %d\n" , i , j ) ; }
			h *= 2 ;
		}
	}
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}

