/**
* user:  A1011
* fname: Tsveta
* lname: Todorova
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 12:17:57.043231
*/
#include<iostream>
#include<vector>
using namespace std;
int z[255][255],n,aF,bF,brA,brB,numBlue[255],numRed[255],totalRed,totalBlue,color[255],color1[255];
vector<int> r[255],b[255];
bool usedA[255],usedB[255];
vector<pair<int,int> > re,be;
void checkA (int pos)
{
    usedA[pos]=true;
    brA++;
    for (int i=0; i<r[pos].size(); i++)
        if (!usedA[r[pos][i]])
            checkA(r[pos][i]);
}
void checkB (int pos)
{
    usedB[pos]=true;
    brB++;
    for (int i=0; i<b[pos].size(); i++)
        if (!usedB[b[pos][i]])
            checkB(b[pos][i]);
}
void dfsA(int pos, int c)
{
    color[pos]=c;
    for (int i=0; i<r[pos].size(); i++)
        if (color[r[pos][i]]==0)
            dfsA(r[pos][i],c);
}
void dfsB(int pos, int c)
{
    color[pos]=c;
    for (int i=0; i<b[pos].size(); i++)
        if (color[b[pos][i]]==0)
            dfsB(b[pos][i],c);
}
int main()
{
    cin>>n;
    for (int i=0; i<n; i++)
        for (int j=0; j<n; j++)
        {
            cin>>z[i][j];
            if (i>=j)
                continue;
            if (!z[i][j])
            {
                totalRed++;
                re.push_back(make_pair(i,j));
                numRed[i]++;
                numRed[j]++;
                r[i].push_back(j);
                r[j].push_back(i);
            }
            else
            {
                totalBlue++;
                be.push_back(make_pair(i,j));
                numBlue[i]++;
                numBlue[j]++;
                b[i].push_back(j);
                b[j].push_back(i);
            }
        }
    cin>>aF>>bF;
    checkA(1);
    checkB(1);
    if (brA!=n && aF==0)
    {
        if (brB!=n && bF==0)
        {
            cout<<"0\n";
            return 0;
        }
        if (brB==n && bF==1)
        {
            cout<<"0\n";
            return 0;
        }
    }
    if (brA==n && aF==1)
    {
        if (brB!=n && bF==0)
        {
            cout<<"0\n";
            return 0;
        }
        if (brB==n && bF==1)
        {
            cout<<"0\n";
            return 0;
        }
    }
    if (aF==0 && bF==0)
    {
        cout<<"-1\n";
        return 0;
    }
    if (n==3 && aF==1 && bF==1)
    {
        cout<<"-1\n";
        return 0;
    }
    if (aF==1 && bF==1)
    {
        if (brA!=n)
        {
            int pos=0,cnt=0;
            vector<pair<int,int> > tobedel;
            for (int i=1; i<=n; i++)
                color1[i]=i;
            while (pos<be.size())
            {
                int u,v;
                u=be[pos].first;
                v=be[pos].second;
                pos++;
                if (color1[u]==color1[v] || numBlue[u]==1 || numBlue[v]==1)
                    continue;
                cnt++;
                numBlue[u]--;
                numBlue[v]--;
                tobedel.push_back(make_pair(u,v));
                int r=color1[u];
                for (int i=0; i<n; i++)
                    if (color1[i]==r)
                        color1[i]=color1[v];
            }
            int duck=1;
            for (int i=0; i<n; i++)
                if (color[i]==0)
                {
                    dfsA(i,duck);
                    duck++;
                }
            cout<<duck-1<<'\n';
            for (int i=0; i<duck; i++)
            {
                for (int j=0; j<tobedel.size(); j++)
                {
                    int u=tobedel[j].first;
                    int v=tobedel[j].second;
                    if (color[u]!=color[v])
                    {
                        cout<<u+1<<' '<<v+1<<'\n';
                        int r=color[v];
                        for (int l=0; l<n; l++)
                            if (color[l]==r)
                                color[l]=color[u];
                        break;
                    }
                }
            }
            return 0;
        }
        else
        {
            int pos=0,cnt=0;
            vector<pair<int,int> > tobedel;
            for (int i=1; i<=n; i++)
                color1[i]=i;
            while (pos<re.size())
            {
                int u,v;
                u=re[pos].first;
                v=re[pos].second;
                pos++;
                if (color1[u]==color1[v] || numRed[u]==1 || numRed[v]==1)
                    continue;
                cnt++;
                numRed[u]--;
                numRed[v]--;
                tobedel.push_back(make_pair(u,v));
                int r=color1[u];
                for (int i=0; i<n; i++)
                    if (color1[i]==r)
                        color1[i]=color1[v];
            }
            int duck=1;
            for (int i=0; i<n; i++)
                if (color[i]==0)
                {
                    dfsB(i,duck);
                    duck++;
                }
            cout<<duck-1<<'\n';
            for (int i=0; i<duck; i++)
            {
                for (int j=0; j<tobedel.size(); j++)
                {
                    int u=tobedel[j].first;
                    int v=tobedel[j].second;
                    if (color[u]!=color[v])
                    {
                        cout<<u+1<<' '<<v+1<<'\n';
                        int r=color[v];
                        for (int l=0; l<n; l++)
                            if (color[l]==r)
                                color[l]=color[u];
                        break;
                    }
                }
            }
            return 0;
        }
    }
}
