/**
* user:  A1016
* fname: Yoana
* lname: Zelova
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 08:15:36.298518
*/
#include<bits/stdc++.h>
using namespace std;

bool used[256];

vector<int> getConnectedPart(int id, vector<vector<int>>& v)
{
    vector<int> rt;
    queue<int> q;
    q.push(id);
    used[id]=true;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        rt.push_back(x);
        for(int i=0; i<v[x].size(); i++)
        {
            if(!used[v[x][i]])
            {
                q.push(v[x][i]);
                used[v[x][i]]=true;
            }
        }
    }
    return rt;
}

void connect(vector<vector<int>>& v, int& n)
{
    vector<vector<int>> parts;
    while(true)
    {
        int id=0;
        for(int i=1; i<=n; i++)
        {
            if(!used[i])
            {
                id=i;
                break;
            }
        }
        if(id==0)break;
        parts.push_back(getConnectedPart(id, v));
    }
    cout<<parts.size()-1<<endl;
    for(int i=0; i<parts.size()-1; i++)
    {
        cout<<parts[i][0]<<" "<<parts[i+1][0]<<endl;
    }
    return ;
}

int main()
{
    int n;
    cin>>n;
    vector<vector<int>> v;
    v.resize(n+1);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            bool b;
            cin>>b;
            if(b && i!=j)
            {
                v[i].push_back(j);
            }
        }
    }
    bool a,b;
    cin>>a>>b;
    if(a==0 && b==0)
    {
        cout<<-1<<endl;
        return 0;
    }
    if(a==0 && b==1)
    {
        connect(v, n);
        return 0;
    }
    return 0;
}
/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

3
0 1 1
1 0 0
1 0 0
1 1

3
0 1 1
1 0 0
1 0 0
0 1
*/
