/**
* user:  A1017
* fname: Atanas
* lname: Dobrev
* task:  colorgraph
* score: 5.0
* date:  2017-11-25 12:34:44.857079
*/
#include<bits/stdc++.h>
using namespace std;
vector<pair<int,int> >G[256];
int sr;
int startt,endd;
int par[256],mas[256];
int par_red[256],par_blue[256];
int m[256][256];
//For normal
int findd(int x)
{
    if(x==par[x])
        return x;
    else return par[x]=findd(par[x]);
}
void unionn(int x,int y)
{
    int now1=findd(x),now2=findd(y);
    par[now1]=now2;
}
//For Red
int findd_red(int x)
{
    if(x==par_red[x])
        return x;
    else return par_red[x]=findd_red(par_red[x]);
}
void unionn_red(int x,int y)
{
    int now1=findd_red(x),now2=findd_red(y);
    par_red[now1]=now2;
}
//For Blue
int findd_blue(int x)
{
    if(x==par_blue[x])
        return x;
    else return par_blue[x]=findd_blue(par_blue[x]);
}
void unionn_blue(int x,int y)
{
    int now1=findd_blue(x),now2=findd_blue(y);
    par_blue[now1]=now2;
}
int main()
{
    for(int i=1;i<=250;i++)
        par[i]=i;
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin>>n;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
        {
            cin>>m[i][j];
            if(i!=j)
            {
                G[i].push_back(make_pair(j,m[i][j]));
            }
        }
    cin>>startt>>endd;
    if(startt==0 && endd==0)
    {
        cout<<-1<<endl;
    }
    else if(startt==1 && endd==1)
    {
        if(n<=7)
        {
            int MINANS=62500;
            vector<pair<int,int> >ANSWER;
            int br=n*(n-1)/2,mask=(1<<br);
            for(int i=0;i<mask;i++)
            {
                for(int Q=1;Q<=n;Q++)
                    par_red[Q]=par_blue[Q]=Q;
                int matrix[10][10];
                memset(matrix,0,sizeof(matrix));
                int nowl=1,nowr=2;
                for(int j=br-1;j>=0;j--)
                {
                    int NOW=(1<<j);
                    if(((NOW)&(i))!=0)
                    {
                        matrix[nowl][nowr]=1;
                    }
                    nowr++;
                    if(nowr>n)
                    {
                        nowr=++nowl;
                        nowr++;
                    }
                }
                for(int j=1;j<=n;j++)
                {
                    for(int Q=j+1;Q<=n;Q++)
                    {
                        if(Q!=j)
                        {
                            if(matrix[j][Q]==1)
                            {
                                if(findd_red(j)!=findd_red(Q))
                                    unionn_red(j,Q);
                            }
                            else
                            {
                                if(findd_blue(j)!=findd_blue(Q))
                                    unionn_blue(j,Q);
                            }
                        }
                    }
                }
                int brred=0,brblue=0;
                for(int j=1;j<=n;j++)
                {
                    if(findd_red(j)==j)
                    {
                        brred++;
                    }
                    if(findd_blue(j)==j)
                    {
                        brblue++;
                    }
                }
                if(brred==1 && brblue==1)
                {
                    int TEKANS=0;
                    vector<pair<int,int> >TEKANSWER;
                    for(int j=1;j<=n;j++)
                    {
                        for(int Q=j+1;Q<=n;Q++)
                        {
                            if(matrix[j][Q]!=m[j][Q])
                            {
                                TEKANS++;
                                TEKANSWER.push_back(make_pair(j,Q));
                            }
                        }
                    }
                    if(TEKANS<MINANS)
                    {
                        MINANS=TEKANS;
                        ANSWER=TEKANSWER;
                    }
                }
            }
            cout<<MINANS<<endl;
            if(MINANS)
            {
                for(int i=0;i<ANSWER.size();i++)
                cout<<ANSWER[i].first<<" "<<ANSWER[i].second<<endl;
            }
        }
        else
        {
            cout<<-1<<endl;
        }
    }
    else
    {
        sr=endd;
        for(int i=1;i<=n;i++)
        {
            for(int j=0;j<G[i].size();j++)
            {
                if(G[i][j].second==sr)
                {
                    if(findd(i)!=findd(G[i][j].first))
                        unionn(i,G[i][j].first);
                }
            }
        }
        for(int i=1;i<=n;i++)
            mas[i]=(findd(i)==i);
        vector<int>v;
        for(int i=1;i<=n;i++)
            if(mas[i])v.push_back(i);
        cout<<v.size()-1<<endl;
        if(v.size()!=1)
        {
            for(int i=0;i<v.size()-1;i++)
                cout<<v[i]<<" "<<v[i+1]<<endl;
        }
    }
    return 0;
}
/*
10
0 0 0 0 0 0 0 1 0 1
0 0 0 0 0 1 0 0 0 0
0 0 0 1 0 0 0 0 0 0
0 0 1 0 0 0 0 0 1 0
0 0 0 0 0 0 0 0 0 0
0 1 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0
1 0 0 0 0 0 0 0 0 0
0 0 0 1 0 0 0 0 0 0
1 0 0 0 0 0 0 0 0 0

5
1 1 1 1 1
1 1 1 1 1
1 1 1 1 1
1 1 1 1 1
1 1 1 1 1
1 1
*/

