/**
* user:  A1019
* fname: Vasilena
* lname: Cvetanova
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 11:16:42.961012
*/
#include<bits/stdc++.h>
const int MAXN=10;
using namespace std;

vector<vector<int> > on, tw;
bool u1[MAXN], u2[MAXN];
int best=1e9;
int n;
int G[MAXN][MAXN];

void dfs1(int u)
{
    u1[u]=1;
    for(int i=0; i<on[u].size(); i++) if(!u1[on[u][i]]) dfs1(on[u][i]);
}

void dfs2(int u)
{
    u2[u]=1;
    for(int i=0; i<tw[u].size(); i++) if(!u2[tw[u][i]]) dfs2(tw[u][i]);
}

pair<int, int> nx(pair<int, int> &a)
{
    a.second++;
    a.second%=n;
    if(a.second<=a.first) return make_pair(a.first+1, a.first+2);

    return a;
}

void mainp()
{
    cin>>n;
    cout<<n<<endl;
    for(int i=0; i<n; i++)
        for(int j=0; j<n; j++) cin>>G[i][j];

    int need1, need2;
    cin>>need1>>need2;

    int cnt=n*(n-1)/2;

    pair<int, int> temp=make_pair(0, 1);
    string s="";
    for(int i=0; i<cnt; i++)
    {
        s+=(G[temp.first][temp.second]==1?'1':'0');
        temp=nx(temp);
    }

    //cout<<s<<endl;
    on.resize(n);
    tw.resize(n);

    for(int i=0; i<(1<<cnt); i++)
    {
        if(__builtin_popcount(i)>best) continue;
        temp=make_pair(0, 1);
        for(int j=0; j<n; j++) on[j].clear(), tw[j].clear();
        for(int j=0; j<n; j++) u1[j]=u2[j]=0;
        int price=0;

        for(int bit=0; bit<cnt; bit++)
        {
            if(i&(1<<bit))
            {
                on[temp.first].push_back(temp.second);
                on[temp.second].push_back(temp.first);
            }
            else
            {
                tw[temp.first].push_back(temp.second);
                tw[temp.second].push_back(temp.first);
            }
            temp=nx(temp);
        }

        int comp1=1, comp2=1;
        for(int j=0; j<n; j++) if(u1[j]==0&&on[j].size()) {dfs1(j); break;}
        for(int j=0; j<n; j++) if(u2[j]==0&&tw[j].size()) {dfs2(j); break;}

        for(int j=0; j<n; j++) if(u1[j]==0) comp1=0;
        for(int j=0; j<n; j++) if(u2[j]==0) comp2=0;

//        cout<<comp1<<" "<<comp2<<" "<<need1<<" "<<need2<<endl;
        if(comp1==need2&&comp2==need1)
        {
            for(int bit=0; bit<cnt; bit++)
            {
                if(i&(1<<bit))
                {
                    if(s[bit]=='0') price++;
                    //cout<<1;
                }
                else
                {
                    if(s[bit]=='1') price++;
                    //cout<<0;
                }
            }
            //cout<<endl;
            best=min(best, price);
        }
    }

    if(best==1e9) cout<<-1<<endl;
    else cout<<best<<endl;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mainp();
    return 0;
}

/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

3
0 1 1
1 0 0
1 0 0
1 1

3
0 1 1
1 0 0
1 0 0
0 1

*/

