/**
* user:  A1020
* fname: Emil
* lname: Indzhev
* task:  clubs
* score: 0.0
* date:  2017-11-25 08:00:51.371879
*/
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

const int MAX_N=100100;
const int MAX_LOG=20;
int n;
int k;
int min_mem;
vector<int> members[MAX_LOG];
priority_queue<pair<int,int> > pq;


void input()
{
    cin>>n;
}

void output()
{
    cout<<k<<' '<<min_mem<<'\n';
    for (int i=0;i<k;++i)
    {
        cout<<members[i].size();
        for (int j=0;j<members[i].size();++j)
        {
            cout<<' '<<members[i][j];
        }
        cout<<'\n';
    }
}

int my_log(int a)
{
    int ans=0;
    int p=1;
    while (p<a)
    {
        p*=2;
        ++ans;
    }
    return ans;
}

long long comb[MAX_LOG];
void find_comb()
{
    comb[0]=1;
    for (int i=1;i<=k;++i)
    {
        comb[i]=comb[i-1]*(k-i+1)/i;
    }
}
void find_clubs()
{
    pair<int, int> p;
    for (int i=0;i<k;++i)
    {
        pq.push({0,i});
    }
    int curr=0;
    for (int i=0;i<n;++i)
    {
        for (int j=0;j<curr;++j)
        {
            p=pq.top();
            pq.pop();
            members[p.second].push_back(i+1);
            --p.first;
            pq.push(p);
        }
        if (--comb[curr]==0) ++curr;
    }
    min_mem=members[0].size();
    for (int i=1;i<k;++i)
    {
        if (members[i].size()>min_mem) min_mem=members[i].size();
    }
}
void solve()
{
    k=my_log(n);
    find_comb();
    find_clubs();
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
