/**
* user:  A1020
* fname: Emil
* lname: Indzhev
* task:  crypto
* score: 15.0
* date:  2017-11-25 12:43:33.656569
*/
#include<iostream>
#include<algorithm>
#include<math.h>
#include<stdlib.h>
#include<vector>
using namespace std;
int n,k,p;
long long ans;
const int MAX_N=400;
const int MAX_NK=30100;
const long long MOD=(1e9)+7;
void input()
{
    cin>>n>>k>>p;
}
long long dp[MAX_N][MAX_NK];
void calc()
{
    long long fact=1;
    for (int i=k-2;i<k;++i)
    {
        if (i>0)
        {
            fact*=i;
            fact%=MOD;
        }
        for (int j=1;j<=p;++j)
        {
            dp[i][i]=0;
        }
        dp[i][0]=fact;
    }
    int gain;
    for (int i=k;i<=n;++i)
    {
        for (int q=0;q<=p;++q)
        {
            dp[i][q]=0;
            //cerr<<": "<<i<<" "<<q<<endl;
            for (int j=1;j<=min(i/2,k);++j)
            {
                gain=min(j,i-k+1);
                //cerr<<"j: "<<j<<" "<<gain<<endl;
                if (gain>q) break;
                //cerr<<2*dp[i-1][q-gain]<<endl;
                dp[i][q]+=2*dp[i-1][q-gain];
                dp[i][q]%=MOD;

            }
            //cerr<<i<<" "<<q<<" "<<dp[i][q]<<endl;
            if (2*k<i && k<=q) dp[i][q]+=(i-2*k)*dp[i-1][q-k];
            else if (i%2==1 && i-k+1<=q) dp[i][q]+=dp[i-1][q-(i-k+1)];
            //cerr<<i<<" "<<q<<" "<<dp[i][q]<<endl;
            dp[i][q]%=MOD;
        }
    }
}
void output()
{
    cout<<ans<<endl;
}
void solve()
{
    calc();
    ans=dp[n][p];
    /*for (int i=0;i<=n;++i)
    {
        for (int j=0;j<=p;++j)
        {
            if (dp[i][j]>0) cerr<<"x "; //cerr<<dp[i][j]<<" ";
            else cerr<<"0 ";
        }
        cerr<<endl;
    }*/
}
int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
