/**
* user:  A1020
* fname: Emil
* lname: Indzhev
* task:  clubs
* score: 45.0
* date:  2017-11-25 12:44:44.869199
*/
#include <iostream>
#include <vector>
#include <queue>
#include <stdlib.h>
using namespace std;

const int MAX_N=100100;
const int MAX_LOG=20;
int n;
int k;
int min_mem,max_clubs;
vector<int> members[MAX_LOG];
priority_queue<pair<int,int> > pq;


void input()
{
    cin>>n;
}

void output()
{
    cout<<k<<' '<<min_mem<<'\n';
    for (int i=0; i<k; ++i)
    {
        cout<<members[i].size();
        for (int j=0; j<members[i].size(); ++j)
        {
            cout<<' '<<members[i][j];
        }
        cout<<'\n';
    }
}

int my_log(int a)
{
    int ans=0;
    int p=1;
    while (p<a)
    {
        p*=2;
        ++ans;
    }
    return ans;
}

long long comb[MAX_LOG];
void find_comb()
{
    comb[0]=1;
    for (int i=1; i<=k; ++i)
    {
        comb[i]=comb[i-1]*(k-i+1)/i;
    }
}
int extra=0;
void find_max_clubs()
{
    max_clubs=0;
    long long total=comb[0];
    while (total<n)
    {
        total+=comb[++max_clubs];
    }
    extra=total-n;
}
int ones(int a)
{
    int o=0;
    while(a>0)
    {
        o+=1&a;
        a=a>>1;
    }
    return o;
}
void put_ones(int a, int mem)
{
    int c=0;
    while(a>0)
    {
        if (1&a)
        {
            members[c].push_back(mem);
        }
        ++c;
        a=a>>1;
    }
}
int cm=1;
void sol1()
{
    pair<int, int> p;
    for (int i=0; i<k; ++i)
    {
        pq.push( {0,i});
    }
    for (; cm<=n; ++cm)
    {
        for (int j=0; j<max_clubs; ++j)
        {
            p=pq.top();
            pq.pop();
            members[p.second].push_back(cm);
            --p.first;
            pq.push(p);
        }
    }
}
vector<pair<int, int> > used;
vector<pair<int, int> > unused;
void sol3()
{
    pair<int, int> p;
    for (int i=0; i<k; ++i)
    {
        unused.push_back( {0,i});
    }
    int curr_val=unused[0].first;
    int cntr=0;
    for (; cm<=n; ++cm)
    {
        for (int j=0; j<max_clubs; ++j)
        {
            if (unused.size()<=cntr || curr_val>unused[cntr].first)
            {
                //cerr<<used.size()<<" "<<curr_val<<endl;
                for (int i=0; i<used.size(); ++i)
                {
                    swap(used[i],used[i+rand()%(used.size()-i)]);
                }
                //cerr<<"push: ";
                unused.resize(0);
                for (int i=0; i<used.size(); ++i)
                {
                    //cerr<<used[i].second<<" ";
                    unused.push_back(used[i]);
                }
                cntr=0;
                //cerr<<endl;
                used.resize(0);
            }
            p=unused[cntr];
            ++cntr;
            pq.pop();
            curr_val=p.first;
            members[p.second].push_back(cm);
            --p.first;
            //cerr<<"in used: "<<p.second<<endl;
            used.push_back(p);
            //pq.push(p);
        }
    }
}
vector<int> poss;
int ppl[MAX_LOG];
int max_club_ones(int a, int max)
{
    int c=0;
    while(a>0)
    {
        if (1&a)
        {
            if (ppl[c]>=max)
            {
                return 0;
            }
        }
        ++c;
        a=a>>1;
    }
    return 1;
}
int put_ones2(int a)
{
    int c=0;
    while(a>0)
    {
        if (1&a)
        {
            ++ppl[c];
        }
        ++c;
        a=a>>1;
    }
}
void sol2()
{
    for (int i=0; i<(1<<k); ++i)
    {
        if (ones(i)==max_clubs)
        {
            //cerr<<"num: "<<i<<endl;
            poss.push_back(i);
        }
    }
    for (int i=0; i<poss.size(); ++i)
    {
        swap(poss[i],poss[rand()%(poss.size()-i)+i]);
    }
    int l=0,r=n;
    int m;
    int c;
    while (l<r)
    {
        m=(l+r)/2;
        //cerr<<l<<" "<<m<<" "<<r<<endl;
        c=0;
        for (int i=0; i<k; ++i)
        {
            //cerr<<ppl[i]<<" ";
            ppl[i]=0;
        }
        //cerr<<endl;
        for (int i=0; i<poss.size(); ++i)
        {
            //cerr<<"check: "<<poss[i]<<endl;
            if (max_club_ones(poss[i],m))
            {
                //cerr<<"valid"<<endl;
                ++c;
                put_ones2(poss[i]);
                /*for (int i=0; i<k; ++i)
                {
                    cerr<<ppl[i]<<" ";
                }
                cerr<<endl;*/
                if (c>n-cm) break;
            }
        }
        if (c>n-cm)
        {
            r=m;
        }
        else
        {
            l=m+1;
        }
    }
    //cerr<<"new ppl:"<<l<<endl;
    for (int i=0; i<k; ++i)
    {
        ppl[i]=0;
    }
    for (int i=0; cm<=n; ++i)
    {
        if (max_club_ones(poss[i],l))
        {
            ++cm;
            put_ones2(poss[i]);
            put_ones(poss[i],cm++);
        }
    }
}
int GCD(int a, int b)
{
    if (a<b) swap(a,b);
    int k;
    while (b>0)
    {
        k=b;
        b=a%b;
        a=k;
    }
    return a;
}
void find_clubs()
{
    for (int i=0; i<=max_clubs-((extra==0)?0:1); ++i)
    {
        for (int j=0;; ++j)
        {
            if (ones(j)==i)
            {
                put_ones(j,cm);
                ++cm;
                --comb[i];
                if (comb[i]==0) break;
            }
        }
    }


    if (extra>0)
    {
        if (GCD(max_clubs,k)==1)
            sol1();
        else if (n<=15)
            sol2();
        else
            sol3();
    }
    min_mem=members[0].size();
    for (int i=1; i<k; ++i)
    {
        if (members[i].size()>min_mem) min_mem=members[i].size();
    }
}
void solve()
{
    k=my_log(n);
    find_comb();
    find_max_clubs();
    //cerr<<' '<<k<<' '<<max_clubs<<' '<<extra<<endl;
    find_clubs();
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    srand(42);

    input();
    solve();
    output();

    return 0;
}
