/**
* user:  A1021
* fname: Ivailo
* lname: Georgiev
* task:  crypto
* score: 5.0
* date:  2017-11-25 08:12:19.186149
*/
#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <cstring>
#include <algorithm>
using namespace std;
const int MAX_N = 512;
const int MOD = 1e9 + 7;
int N, K, P;
vector <int> v;
int fir[MAX_N], perm[MAX_N], ans, curans, real[MAX_N];
bool usedp[4000000];
bool used[MAX_N];
void check()
{
    for(int i = 1; i <= N; ++ i)   real[i] = fir[perm[i]];
    for(int i = 1; i <= N; ++ i)
    {
        for(int j = K; i + j - 1 <= N; ++ j)
        {
            for(int p = i; p <= i + j - 1; ++ p)   v.push_back(real[p]);
            sort(v.begin(), v.end());
            int curr = 1;
            for(int p = 0; p < K; ++ p)   curr *= v[p];
            if(!usedp[curr])
            {
                usedp[curr] = true;
                ++ curans;
            }
            v.clear();
        }
    }
    if(curans == P)
    {
        ++ ans;
        if(ans == MOD)   ans = 0;
    }
    memset(usedp, false, sizeof(usedp));
    curans = 0;
}
void solve(int x)
{
    if(x == N + 1)   check();
    for(int i = 1; i <= N; ++ i)
    {
        if(!used[i])
        {
            used[i] = true;
            perm[x] = i;
            solve(x + 1);
            used[i] = false;
        }
    }
}
void simple(int x)
{
    int curr = 0;
    for(int i = 2; ; ++ i)
    {
        bool l = false;
        for(int j = 2; j <= sqrt(i); ++ j)
        {
            if(i % j == 0)
            {
                l = true;
                break;
            }
        }
        if(l == false)
        {
            ++ curr;
            fir[curr] = i;
            if(curr == x)   break;
        }
    }
}
int main()
{
    cin >> N >> K >> P;
    simple(N);
    solve(1);
    cout << ans << "\n";
    return 0;
}
