/**
* user:  A1021
* fname: Ivailo
* lname: Georgiev
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 10:21:30.754546
*/
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
const int MAX_N = 256;
const int INF = 500;
int N, A, B, brr[MAX_N], brb[MAX_N];
bool a[MAX_N][MAX_N];
struct edge
{
    int to;
    bool b;
    edge(){}
    edge(int _to, bool _b)
    {
        to = _to;
        b = _b;
    }
};
vector <edge> v[MAX_N];
vector <int> real[2];
int ans = INF;
bool prom[MAX_N][MAX_N], used[MAX_N];
void dfsr(int x)
{
    used[x] = true;
    int sz = v[x].size();
    for(int i = 0; i < sz; ++ i)
    {
        int curr = v[x][i].to;
        if(used[curr] == false && v[x][i].b == false)   dfsr(curr);
    }
}
void dfsb(int x)
{
    used[x] = true;
    int sz = v[x].size();
    for(int i = 0; i < sz; ++ i)
    {
        int curr = v[x][i].to;
        if(used[curr] == false && v[x][i].b == true)   dfsb(curr);
    }
}
void check()
{
    /**for(int i = 1; i <= N; ++ i)
    {
        for(int j = 1; j <= N; ++ j)   cout << prom[i][j] << " ";
        cout << endl;
    }
    cout << endl;**/
    int cur = 0;
    for(int i = 1; i <= N; ++ i)
    {
        int sz = v[i].size();
        for(int j = 0; j < sz; ++ j)
        {
            int curr = v[i][j].to;
            if(prom[i][curr] == true)
            {
                ++ cur;
                v[i][j].b ^= 1;
            }
        }
    }
    bool l1 = false, l2 = false;
    dfsr(1);
    for(int i = 1; i <= N; ++ i)
    {
        if(!used[i])
        {
            l1 = true;
            break;
        }
    }
    memset(used, false, sizeof(used));
    dfsb(1);
    for(int i = 1; i <= N; ++ i)
    {
        if(!used[i])
        {
            l2 = true;
            break;
        }
    }
    memset(used, false, sizeof(used));
    if(A == 1 && B == 1 && l1 == false && l2 == false)
    {
        cur /= 2;
        if(cur < ans)
        {
            ans = cur;
            for(int i = 0; i < 2; ++ i)   real[i].clear();
            for(int i = 1; i <= N; ++ i)
            {
                for(int j = i + 1; j <= N; ++ j)
                {
                    if(prom[i][j] == true)
                    {
                        real[0].push_back(i);
                        real[1].push_back(j);
                    }
                }
            }
        }
    }
    else if(A == 0 && B == 0 && l1 == true && l2 == true)
    {
        cur /= 2;
        if(cur < ans)
        {
            ans = cur;
            for(int i = 0; i < 2; ++ i)   real[i].clear();
            for(int i = 1; i <= N; ++ i)
            {
                for(int j = i + 1; j <= N; ++ j)
                {
                    if(prom[i][j] == true)
                    {
                        real[0].push_back(i);
                        real[1].push_back(j);
                    }
                }
            }
        }
    }
    else if(A == 0 && B == 1 && l1 == true && l2 == false)
    {
        cur /= 2;
        if(cur < ans)
        {
            ans = cur;
            real[0].clear();
            real[1].clear();
            for(int i = 1; i <= N; ++ i)
            {
                for(int j = i + 1; j <= N; ++ j)
                {
                    if(prom[i][j] == true)
                    {
                        real[0].push_back(i);
                        real[1].push_back(j);
                    }
                }
            }
        }
    }
    else if(A == 1 && B == 0 && l1 == false && l2 == true)
    {
        cur /= 2;
        if(cur < ans)
        {
            ans = cur;
            real[0].clear();
            real[1].clear();
            for(int i = 1; i <= N; ++ i)
            {
                for(int j = i + 1; j <= N; ++ j)
                {
                    if(prom[i][j] == true)
                    {
                        real[0].push_back(i);
                        real[1].push_back(j);
                    }
                }
            }
        }
    }
    for(int i = 1; i <= N; ++ i)
    {
        int sz = v[i].size();
        for(int j = 0; j < sz; ++ j)
        {
            int curr = v[i][j].to;
            if(prom[i][curr] == true)
            {
                v[i][j].b ^= 1;
            }
        }
    }
}
void solve(int x, int y)
{
    if(x == N && y == N)
    {
        check();
        return;
    }
    if(x == y)   solve(x, y + 1);
    prom[x][y] = false;
    prom[y][x] = false;
    if(y == N)   solve(x + 1, x + 1);
    else   solve(x, y + 1);
    prom[x][y] = true;
    prom[y][x] = true;
    if(y == N)   solve(x + 1, x + 1);
    else   solve(x, y + 1);
}
int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cin >> N;
    for(int i = 1; i <= N; ++ i)
    {
        for(int j = 1; j <= N; ++ j)
        {
            cin >> a[i][j];
            if(i != j)
            {
                if(a[i][j] == false)   ++ brr[i];
                else   ++ brb[i];
                v[i].push_back(edge(j, a[i][j]));
            }
        }
    }
    cin >> A >> B;
    solve(1, 1);
    if(ans == INF)
    {
        cout << "-1\n";
        return 0;
    }
    cout << ans << "\n";
    int sz = real[0].size();
    for(int i = 0; i < sz; ++ i)   cout << real[0][i] << " " << real[1][i] << "\n";
    return 0;
}
/**
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1
**/
