/**
* user:  A1024
* fname: Yordan
* lname: Dimitrov
* task:  colorgraph
* score: 5.0
* date:  2017-11-25 07:49:26.982015
*/
#include<bits/stdc++.h>
#define MAX_N 256
using namespace std;
int n, parent[MAX_N], depth[MAX_N];
int a[MAX_N][MAX_N], setcnt=1;
bool state;
int get_parent(int u)
{
    return (u==parent[u]) ? u : parent[u]=get_parent(parent[u]);
}
void unite(int u, int v)
{
    u=get_parent(u);
    v=get_parent(v);
    if(u==v)
        return;
    setcnt++;
    if(depth[v]>depth[u])
        swap(u, v);
    parent[v]=u;
    if(depth[u]==depth[v])
        depth[v]++;
}
void print()
{
    for(int i=1; i<=n; i++)
        printf("%d ", parent[i]);
    printf("\n");
}
void init()
{
    for(int i=1; i<=n; i++)
    {
        parent[i]=i;
        depth[i]=0;
    }
}
void read()
{
    scanf("%d", &n);
    for(int i=1; i<=n; i++)
        for(int j=1; j<=n; j++)
            scanf("%d", &a[i][j]);
    int x, y;
    scanf("%d %d", &x, &y);
    state=max(0, y-x);
}
void solve()
{
    for(int i=1; i<=n; i++)
        for(int j=i+1; j<=n; j++)
            if(a[i][j]==state)
                unite(i, j);
    //print();
    vector<pair<int, int>> ans;
    for(int i=1; i<=n; i++)
        for(int j=i+1; j<=n; j++)
            if(a[i][j]!=state)
                if(get_parent(i)!=get_parent(j))
                {
                    unite(i, j);
                    ans.push_back(make_pair(i, j));
                }
    //cerr<<"-----------\n";
    if(setcnt<n)
    {
        printf("-1\n");
        return;
    }
    int sz=ans.size();
    printf("%d\n", sz);
    for(int i=0; i<sz; i++)
        printf("%d %d\n", ans[i].first, ans[i].second);
}
int main()
{
    //freopen("input.txt", "r", stdin);
    read();
    init();
    solve();
    return 0;
}
