/**
* user:  A1024
* fname: Yordan
* lname: Dimitrov
* task:  crypto
* score: 10.0
* date:  2017-11-25 11:19:16.451439
*/
#include<bits/stdc++.h>
#define MAX_N 100
#define MOD 1000000007
using namespace std;
bool notPrime[MAX_N];
int n, k, p, currperm[MAX_N];
vector<int> primes;
void print();
void read()
{
    scanf("%d %d %d", &n, &k, &p);
    for(int i=1; i<=n; i++)
        currperm[i]=i;
}
void print()
{
    for(int i=1; i<=n; i++)
        printf("%d ", currperm[i]);
    printf("\n");
}
void sieve()
{
    primes.push_back(-1);
    for(int i=2; i*i<MAX_N; i++)
        for(int j=i*i; j<MAX_N; j+=i)
            notPrime[j]=1;
    for(int i=2; i<=MAX_N; i++)
        if(!notPrime[i])
            primes.push_back(i);
}
bool check()
{
    unordered_set<long long int> prod;
    vector<int> sequence;
    long long int product=1;
    int cnt=0;
    for(int i=1; i<=n; i++)
        for(int length=k; length+i-1<=n; length++)
        {
            for(int j=i; j<=i+length-1; j++)
            {
                sequence.push_back(primes[currperm[j]]);
                //cerr<<primes[currperm[j]]<<' ';
            }
            //cerr<<endl;
            product=1;
            sort(sequence.begin(), sequence.end());
            for(int j=0; j<k; j++)
                product*=sequence[j];
            if(prod.find(product)==prod.end())
            {
                //cerr<<product<<endl;
                prod.insert(product);
                cnt++;
            }
            sequence.clear();
        }
    if(cnt==p)
        return 1;
    return 0;
}
void solve()
{
    int ans=0;
    do
    {
        if(check())
        {
            ans++;
            if(ans>=MOD)
                ans-=MOD;
        }
    }
    while(next_permutation(currperm+1, currperm+1+n));
    printf("%d\n", ans);
}
int main()
{
    //freopen("input.txt", "r", stdin);
    read();
    sieve();
    solve();
    //currperm[1]=4;
    //currperm[2]=1;
   // currperm[3]=3;
    //currperm[4]=2;
    //cerr<<check()<<endl;
    return 0;
}
