/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  clubs
* score: 30.0
* date:  2017-11-25 07:47:22.409068
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1e5 + 5;

bool IsPowerOfTwo(int n);

vector< int > clubs[MAX_N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;

	n--;

	int maxCntBits = 0, maxCntInClub = 0;
	for(int i = 1; i <= n; i++) {
		int currBit = 0;

		while((1 << currBit) <= i) {
			if(currBit + 1 > maxCntBits) {
				maxCntBits = currBit + 1;
			}

			if((i & (1 << currBit)) != 0) {
				clubs[currBit].push_back(i);
				if(clubs[currBit].size() > maxCntInClub) {
					maxCntInClub = clubs[currBit].size();
				}
			}
			
			currBit++;
		}
	}

	cout << maxCntBits << " " << maxCntInClub << endl;
	for(int i = 0; i < maxCntBits; i++) {
		cout << clubs[i].size() << " ";
		for(int x : clubs[i]) {
			cout << x << " ";
		}
		cout << endl;
	}

	return 0;
}

bool IsPowerOfTwo(int n) {
	int currBit = 0;
	while((1 << currBit) < n) {
		currBit++;
	}
	
	return ((1 << currBit) == n);
}
