/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  clubs
* score: 0.0
* date:  2017-11-25 11:52:28.093248
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1e5 + 5;

int CalcCntOnes(int n);
int LeftmostOneInd(int n);

bool isInLast[MAX_N];
int inds[MAX_N];
vector< int > clubs[MAX_N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	
	int removedNumber = 0, maxCntOnes = 0, maxOneInd = 0;
	for(int i = 1; i <= n; i++) {
		if(LeftmostOneInd(i) > maxOneInd) {
			maxCntOnes = CalcCntOnes(i);
			maxOneInd = LeftmostOneInd(i);
			removedNumber = i;
		}
		else if(LeftmostOneInd(i) == maxOneInd && CalcCntOnes(i) > maxCntOnes) {
			maxCntOnes = CalcCntOnes(i);
			removedNumber = i;
		}
	}

	int maxCntBits = 0;
	for(int i = 1; i <= n; i++) {
		if(i == removedNumber) {
			continue;
		}

		int currBit = 0;

		while((1 << currBit) <= i) {
			if(currBit + 1 > maxCntBits) {
				maxCntBits = currBit + 1;
			}

			if((i & (1 << currBit)) != 0) {
				clubs[currBit].push_back(i);
			}
			
			currBit++;
		}
	}

	for(int x : clubs[maxCntBits - 1]) {
		isInLast[x] = true;
	}
	
	while(1) {
		for(int i = 0; i < maxCntBits - 1; i++) {
			while(inds[i] < clubs[i].size() && (isInLast[clubs[i][inds[i]]] || CalcCntOnes(clubs[i][inds[i]]) == 1)) {
				inds[i]++;
			}

			if(inds[i] >= clubs[i].size()) {
				continue;
			}

			clubs[maxCntBits - 1].push_back(clubs[i][inds[i]]);
			isInLast[clubs[i][inds[i]]] = true;
			clubs[i].erase(clubs[i].begin() + inds[i]);

			if(clubs[maxCntBits - 1].size() >= clubs[0].size()) {
				break;
			}
		}

		if(clubs[maxCntBits - 1].size() >= clubs[0].size()) {
			break;	
		}
	}

	int maxCntInClub = 0;
	for(int i = 0; i < maxCntBits; i++) {
		maxCntInClub = max(maxCntInClub, (int) clubs[i].size());
	}

	cout << maxCntBits << " " << maxCntInClub << endl;
	for(int i = 0; i < maxCntBits; i++) {
		cout << clubs[i].size() << " ";
		for(int x : clubs[i]) {
			cout << x << " ";
		}
		cout << endl;
	}

	return 0;
}

int CalcCntOnes(int n) {
	int currBit = 0, ans = 0;
	while((1 << currBit) <= n) {
		if((n & (1 << currBit)) != 0) {
			ans++;
		}
		currBit++;
	}
	
	return ans;
}

int LeftmostOneInd(int n) {
	int ans = 0;
	while(n > 0) {
		n >>= 1;
		ans++;
	}

	return ans;
}
