/**
* user:  A1028
* fname: Ralitsa
* lname: Andreeva
* task:  colorgraph
* score: 20.0
* date:  2017-11-25 12:24:23.659828
*/
#include <iostream>
#include <vector>
#include <stack>
using namespace std;
int n,a,b;
int color[300][300];
int br[300][2];
int brb,brr;
int par[300];
int bre;
int ans;
int edges[100000][2];
int comp[2];
int k;
int find_par(int a)
{
    if(par[a]==a)return a;
    int y=find_par(par[a]);
    par[a]=y;
    return y;
}
void unite(int a,int b,int col,bool fl)
{
    int par1=find_par(a);
    int par2=find_par(b);
    if(par1==par2)return;
    if(color[a][b]!=col && fl==0)return;
    if(br[a][col]==n-2 || br[b][col]==n-2)return;
    par[b]=a;
    br[a][col]++;
    br[b][col]++;
    color[a][b]=col+2;
    color[b][a]=col+2;
    comp[col]--;
    if(fl==1)
    {
        edges[k][0]=a;
        edges[k++][1]=b;
    }
}
int main( )
{
    int i,j;
    cin>>n;
    for(i=0; i<n; i++)
    {
        for(j=0; j<n; j++)
        {
            cin>>color[i][j];
            if(i!=j && color[i][j]==0)brr++;
        }
    }
    cin>>a>>b;
    if(a==0 && b==0)cout<<-1<<endl;
    else if(a==0 && b==1)
    {
        int br,maxbr=0,ind=0;
        for(i=0; i<n; i++)
        {
            br=0;
            for(j=0; j<n; j++)
            {
                if(i!=j && color[i][j]==1)br++;
            }
            if(maxbr<br)
            {
                maxbr=br;
                ind=i;
            }
        }
        cout<<n-maxbr-1<<endl;
        for(j=0; j<n; j++)
        {
            if(ind!=j && color[ind][j]==0)cout<<ind+1<<" "<<j+1<<endl;
        }
    }
    else if(a==1 && b==0)
    {
        int br,maxbr=0,ind=0;
        for(i=0; i<n; i++)
        {
            br=0;
            for(j=0; j<n; j++)
            {
                if(i!=j && color[i][j]==0)br++;
            }
            if(maxbr<br)
            {
                maxbr=br;
                ind=i;
            }
        }
        cout<<n-maxbr-1<<endl;
        for(j=0; j<n; j++)
        {
            if(ind!=j && color[ind][j]==1)cout<<ind+1<<" "<<j+1<<endl;
        }
    }
    else if(a==1 && b==1)
    {
        if(n==3)cout<<-1<<endl;
        else
        {
            brb=(n*(n-1)-brr)/2;
            brr=brr>>1;
            bre=(brb+brr)>>1;
            int col;
            if(brr>=brb)col=0;
            else col=1;
            comp[0]=n;
            comp[1]=n;
            for(i=0;i<n;i++)par[i]=i;
            for(i=0;i<n;i++)
            {
                for(j=i+1;j<n;j++)
                {
                    unite(i,j,col,0);
                }
            }
            for(i=0;i<n;i++)
            {
                for(j=i+1;j<n;j++)
                {
                    if(color[i][j]==(col^1) && comp[col]>1)
                    {
                        unite(i,j,col,1);
                    }
                }
            }
            col=col^1;
            for(i=0;i<n;i++)par[i]=i;
            for(i=0;i<n;i++)
            {
                for(j=i+1;j<n;j++)
                {
                    unite(i,j,col,0);
                }
            }
            for(i=0;i<n;i++)
            {
                for(j=i+1;j<n;j++)
                {
                    if(color[i][j]==(col^1) && comp[col]>1)
                    {
                        unite(i,j,col,1);
                    }
                }
            }
            cout<<k<<endl;
            for(i=0;i<k;i++)
            {
                cout<<edges[i][0]+1<<' '<<edges[i][1]+1<<endl;
            }
        }
    }
    return 0;
}
/**
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
1 1
-----
4
1 1 1 1
1 1 0 1
1 0 1 1
1 1 1 1
1 0
------
5
0 0 0 0 1
0 0 0 0 1
0 0 0 0 1
0 0 0 0 1
1 1 1 1 1
1 1
*/
