/**
* user:  A1030
* fname: Kamen
* lname: Hristov
* task:  colorgraph
* score: 10.0
* date:  2017-11-25 12:26:46.209990
*/
#include<iostream>
#include<queue>
#include<cstring>
using namespace std;

int n;
int mat[256][256], used[256], pr[256], arr[256][256], flow[256], sink, tmp, ccount[2];
int w0, w1, c0, c1;

int BFS(int check)
{
    queue<int> q;
    int i, cnt=0;

    for(i=0; i<n; i++) used[i]=0;
    used[0]=1;
    q.push(0);
    cnt=1;

    while(!q.empty())
    {
        for(i=0; i<n; i++)
        {
            if(mat[q.front()][i]==check && used[i]==0 && i!=q.front())
            {
                used[i]=1;
                q.push(i);
                cnt++;
            }
        }
        q.pop();
    }

    if(cnt==n) return 1;
    return 0;
}

int MAX_FLOW(int e)///s vinagi e 0
{
    int i, flag=1, m=0;
    queue<int> q;

    while(1)
    {
        for(i=0; i<n; i++)  used[i]=0;
        while(!q.empty()) q.pop();

        used[0]=1;
        pr[0]= -1;
        q.push(0);
        flag=0;
        flow[0]=1024;

        while(!q.empty())
        {
            for(i=0; i<n; i++)
            {
                if(arr[q.front()][i]!=0 && used[i]==0 && i!=q.front())
                {
                    used[i]=1;
                    q.push(i);
                    pr[i]=q.front();
                    flow[i]= min(flow[q.front()], arr[q.front()][i]);
                    if(i==e)
                    {
                        flag=1;
                        break;
                    }
                }
            }
            q.pop();
            if(flag) break;
        }

        if(flag)
        {
            m++;
            for(i=e;pr[i]!=-1; i=pr[i])
            {
                arr[pr[i]][i]-=flow[e];
                arr[i][pr[i]]+=flow[e];
            }
        }
        else return m;
    }
}

void MIN_CUT(int check)
{
    int i, y, z, len=1024;

    for(z=1; z<n; z++)
    {
        for(i=0; i<n; i++)
        {
            for(y=0; y<n; y++)
            {
                if(mat[i][y]==check) arr[i][y]=1;
                else arr[i][y]=0;
            }
        }

        tmp=MAX_FLOW(z);
        if(tmp<len)
        {
            len=tmp;
            sink=z;
        }
    }

    queue<int> q;
    int rem=ccount[check]/2-len;
    ///cout<<"LOOK "<<len<<endl;
    q.push(1);

    while(!q.empty())
    {
        if(q.front()==0)
        {
            q.pop();
            continue;
        }

        ///cout<<q.front()<<"<<<<<<<"<<endl;
        for(i=0; i<n; i++)
        {
            if(mat[q.front()][i]==check && i!=sink && q.front()!=i)
            {
                mat[q.front()][i]=8;
                mat[i][q.front()]=8;
                rem--;
                q.push(i);
                if(rem==0) break;
            }
        }
        if(rem==0) break;
        q.pop();
    }

    cout<<len<<endl;
    for(i=0; i<n; i++)
    {
        for(y=0; y<n; y++)
        {
            if(mat[i][y]==check && i!=y)
            {
                cout<<i+1<<" "<<y+1<<endl;
                mat[i][y]=8;
                mat[y][i]=8;
            }
        }
    }

    return;
}

int main()
{
    cin>>n;

    int i, y;

    for(i=0; i<n; i++)
    {
        for(y=0; y<n; y++)
        {
            cin>>mat[i][y];
            if(i!=y) ccount[mat[i][y]]++;
        }
    }

    cin>>w0>>w1;
    if(w0==0 && w1==0)
    {
        cout<<"-1"<<endl;
        return 0;
    }


    c0=BFS(0);
    c1=BFS(1);

    if(c0==1 && c1==1)
    {
        if(w0==1 && w1==1)
        {
            cout<<"0"<<endl;
            return 0;
        }

        if(w0==0)
        {
            MIN_CUT(0);
        }
        if(w1==0)
        {
            MIN_CUT(1);
        }
    }

    if(c0==0 && c1==1)
    {
        if(w0==0 && w1==1)
        {
            cout<<"0"<<endl;
            return 0;
        }
        if(w0==1 && w1==0)
        {
            MIN_CUT(1);
        }
        if(w0==1 && w1==1)
        {

        }
    }

    if(c0==1 && c1==0)
    {
        if(w0==1 && w1==0)
        {
            cout<<"0"<<endl;
            return 0;
        }
        if(w0==0 && w1==1)
        {
            MIN_CUT(0);
        }
        if(w0==1 && w1==1)
        {

        }
    }

    return 0;
}
