/**
* user:  A1032
* fname: Tihomir
* lname: Todorov
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 11:17:37.209756
*/
#include <iostream>
#include <vector>
#include <algorithm>
#include <memory.h>
using namespace std;
struct edge
{
    int u, v, tg;
    edge() {};
    edge(int a, int b, int c)
    {
        u=a, v=b, tg=c;
    }
} edges[251];
vector <edge> t;
vector <edge> f;
int n, matr[251][251], a, b, k, parent[251], depth[251], mst, br;
bool cmp1 (edge a, edge b)
{
    return a.tg<b.tg;
}
bool cmp2 (edge a, edge b)
{
    return a.tg>b.tg;
}
int find_root (int r)
{
    int i;
    for (i=r; i!=parent[i]; i=parent[i])
    {
        parent[i]=parent[parent[i]];
    }
    return i;
}
void solve1()
{
    for (int i=0; i<t.size(); i++)
    {
        if (t[i].tg==1) f.push_back(edge(t[i]));
    }
    cout <<f.size()<<endl;
    for (int i=0; i<f.size(); i++)
    {
        cout <<f[i].u<<" "<<f[i].v<<endl;
    }
}
void solve2()
{
    for (int i=0; i<t.size(); i++)
    {
        if (t[i].tg==0) f.push_back(edge(t[i]));
    }
    cout <<f.size()<<endl;
    for (int i=0; i<f.size(); i++)
    {
        cout <<f[i].u<<" "<<f[i].v<<endl;
    }
}
int main ()
{
    t.clear();
    memset(parent,-1,sizeof parent);
    cin >>n;
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=n; j++)
        {
            cin >>matr[i][j];
        }
    }
    cin >>a>>b;
    for (int i=1; i<=n; i++)
    {
        for (int j=1; j<=n; j++)
        {
            if (i==j) continue;
            if (matr[i][j]==-1) continue;
            edges[k++]=edge(i,j,matr[i][j]);
            matr[j][i]=-1;
        }
    }
    for (int i=1; i<=n; i++)
    {
        parent[i]=i;
        depth[i]=1;
    }
    if (a==1 && b==1)
    {
        cout <<-1<<endl;
        return 0;
    }
    if (a==1) sort (edges,edges+n,cmp1);
    else sort(edges,edges+n,cmp2);
    for (int i=0; i<k; i++)
    {
        int ru=find_root(edges[i].u);
        int rv=find_root(edges[i].v);
        if (ru==rv) continue;
        if (depth[ru]<depth[rv]) parent[ru]=rv;
        else if (depth[ru]>depth[rv]) parent[rv]=ru;
        else parent[rv]=ru, depth[ru]++;
        mst+=edges[i].tg;
        t.push_back(edges[i]);
        if (br==n-1) break;
        br++;
    }
    if (br!=n-1) cout <<-1<<endl;
    else
    {
        if (a==1) solve1();
        else solve2();
    }
}
