/**
* user:  A1033
* fname: Antani
* lname: Gospodinov
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 11:40:51.422861
*/
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define mp make_pair
#define pb push_back
using namespace std;
const int N=8;
const int INF=1e9;

int n;
int a[N][N];
int red,blue;

int ans=INF;
vector <pair<int,int> > cur_swaps,swaps;

bool table[N][N];
int cur_diff;
inline void get_table(int mask)
{
   int i,j,len;
   int cur_bit=0;
   for(i=1;i<=n;i++)
   {
       len=i-1;
       while(len)
       {
           table[i][len]=(mask & (1 << cur_bit));
           table[len][i]=table[i][len];
           len--;
           cur_bit++;
       }
   }
 /*  for(i=1;i<=n;i++)
   {
       for(j=1;j<=n;j++)
       {
           cerr<<table[i][j]<<" ";
       }
       cerr<<endl;
   }
   cerr<<endl; */

   cur_diff=0;
   cur_swaps.clear();
   for(i=1;i<=n;i++)
   {
       for(j=i+1;j<=n;j++)
       {
           if(table[i][j] != a[i][j])
           {
            cur_swaps.pb(mp(i,j));
            cur_diff++;
           }
       }
   }
}

bool vis[N];
int visited;
void DFS(int v,bool col)
{
    int i;
    vis[v]=true;
    visited++;
    for(i=1;i<=n;i++)
    {
        if(!vis[i])
        {
            if(table[v][i] == col)
            {
                DFS(i,col);
            }
        }
    }
}

inline void check()
{
   int cur_red,cur_blue;

   visited=0;
   memset(vis,false,sizeof(vis));
   DFS(1,false);
   if(visited == n)
   {
       cur_red=1;
   }
   else
   {
       cur_red=0;
   }

   visited=0;
   memset(vis,false,sizeof(vis));
   DFS(1,true);
   if(visited == n)
   {
       cur_blue=1;
   }
   else
   {
       cur_blue=0;
   }


   if(red == cur_red && blue == cur_blue)
   {
       if(cur_diff < ans)
       {
        ans=cur_diff;
        swaps=cur_swaps;
       }
   }
}


int main()
{
   int i,j;
   int mask;

   scanf("%d", &n);
   for(i=1;i<=n;i++)
   {
       for(j=1;j<=n;j++)
       {
           scanf("%d", &a[i][j]);
       }
   }
   scanf("%d%d", &red, &blue);

   int x=(n*(n-1))/2;

   for(mask=0;mask<(1 << x);mask++)
   {
       get_table(mask);
       check();
   }

   if(ans == INF)
   {
       printf("-1\n");
   }
   else
   {
       printf("%d\n", ans);
       for(i=0;i<ans;i++)
       {
           printf("%d %d\n",swaps[i].first, swaps[i].second);
       }
       if(ans)
        printf("\n");
   }


   return 0;
}

/*
7
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 0
*/
