/**
* user:  A1033
* fname: Antani
* lname: Gospodinov
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 12:34:22.614508
*/
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#define mp make_pair
#define pb push_back
using namespace std;
const int N=8;
const short INF=50;

short n;
bool a[N][N];
bool red,blue;

short ans=INF;
vector <pair<short,short> > cur_swaps,swaps;

bool table[N][N];
short cur_diff;
inline void get_table(int mask)
{
   short i,j,len;
   short cur_bit=0;
   for(i=1;i<=n;i++)
   {
       len=i-1;
       while(len)
       {
           if((mask & (1 << cur_bit)))
            table[i][len]=1^a[i][len];
           else
            table[i][len]=a[i][len];

           table[len][i]=table[i][len];
           len--;
           cur_bit++;
       }
   }
 /*  for(i=1;i<=n;i++)
   {
       for(j=1;j<=n;j++)
       {
           cerr<<table[i][j]<<" ";
       }
       cerr<<endl;
   }
   cerr<<endl; */

   cur_diff=0;
   cur_swaps.clear();
   for(i=1;i<=n;i++)
   {
       for(j=i+1;j<=n;j++)
       {
           if(table[i][j] != a[i][j])
           {
            cur_swaps.pb(mp(i,j));
            cur_diff++;
           }
       }
   }
}

//bool vis[N];
short vis;
short visited;
void DFS(short v,bool col)
{
    short i;
  //  vis[v]=true;
    vis|=(1 << v);
    visited++;
    for(i=1;i<=n;i++)
    {
        if(!(vis & (1 << i)))
        {
            if(table[v][i] == col)
            {
                DFS(i,col);
            }
        }
    }
}

bool retreat;
inline void check()
{
   bool cur_red,cur_blue;

   visited=0;
  // memset(vis,false,sizeof(vis));
   vis=0;
   DFS(1,false);
   if(visited == n)
   {
       cur_red=true;
   }
   else
   {
       cur_red=false;
   }

   visited=0;
  // memset(vis,false,sizeof(vis));
   vis=0;
   DFS(1,true);
   if(visited == n)
   {
       cur_blue=true;
   }
   else
   {
       cur_blue=false;
   }


   if(red == cur_red && blue == cur_blue)
   {
       if(cur_diff < ans)
       {
        ans=cur_diff;
        swaps=cur_swaps;

        retreat=true;
       }
   }
}

bool ppc_sort(int x,int y)
{
    return __builtin_popcount(x) < __builtin_popcount(y);
}

vector <int> m;

int main()
{
   short i,j;
   int mask;

   ios_base::sync_with_stdio(false);
   cin.tie(NULL);

   //scanf("%d", &n);
   cin>>n;
   for(i=1;i<=n;i++)
   {
       for(j=1;j<=n;j++)
       {
          // scanf("%d", &a[i][j]);
          cin>>a[i][j];
       }
   }
  // scanf("%d%d", &red, &blue);
   cin>>red>>blue;

   if(n > 7)
   {
       cout<<-1<<endl;
   }

   int x=(n*(n-1))/2;

   for(mask=0;mask<(1 << x);mask++)
   {
     m.pb(mask);
   }
   sort(m.begin(),m.end(),ppc_sort);

   for(mask=0;mask<(1 << x);mask++)
   {
       if(retreat)
        break;
       if(clock()/(double)CLOCKS_PER_SEC >= 1.95)
        break;
       get_table(m[mask]);
       check();
   }

   if(ans == INF)
   {
      // printf("-1\n");
      cout<<-1<<endl;
   }
   else
   {
       //printf("%d\n", ans);
       cout<<ans<<endl;
       for(i=0;i<ans;i++)
       {
           //printf("%d %d\n",swaps[i].first, swaps[i].second);
           cout<<swaps[i].first<<" "<<swaps[i].second<<endl;
       }
       if(ans)
        cout<<endl;
   }

   return 0;
}

/*
7
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 1 1 1 1 1 1
1 0
*/
