/**
* user:  A1034
* fname: Daniel
* lname: Danailov
* task:  colorgraph
* score: 20.0
* date:  2017-11-25 08:18:29.315541
*/
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

const int N=255;

int g[N][N],rc[N],bc[N];
int redcomp,bluecomp;
vector < pair <int,int> > ans;
bool used[N];
int n;

void Clear()
{
 int i;

  for(i=1;i<=n;i++)
   used[i]=false;
}

void DFS(int v,int color)
{
 int i;

 used[v]=true;

 if(color==0)
  rc[v]=redcomp;
 else
  bc[v]=bluecomp;

  for(i=1;i<=n;i++)
   if(!used[i] && g[v][i]==color)
    DFS(i,color);
}

int main()
{

int i,j,z,cnt,cc,sz,p,q;

scanf("%d",&n);

 for(i=1;i<=n;i++)
  for(j=1;j<=n;j++)
   scanf("%d",&g[i][j]);

scanf("%d%d",&p,&q);

redcomp=0;
 for(i=1;i<=n;i++)
  if(!used[i])
  {
   redcomp++;
   DFS(i,0);
  }

Clear();

bluecomp=0;
 for(i=1;i<=n;i++)
  if(!used[i])
  {
   bluecomp++;
   DFS(i,1);
  }

 for(i=1;i<=n;i++)
  for(j=i+1;j<=n;j++)
   if(rc[i]!=rc[j])
   {
    g[i][j]^=1;
    g[j][i]^=1;

    Clear();
    cnt=0;
     for(z=1;z<=n;z++)
      if(!used[z])
      {
       cnt++;
       DFS(z,1);
      }

     if(cnt==bluecomp)
     {
      ans.push_back(make_pair(i,j));
      redcomp--;
      cc=rc[j];
       for(z=1;z<=n;z++)
        if(rc[z]==cc)
         rc[z]=rc[i];
     }
     else
     {
      g[i][j]^=1;
      g[j][i]^=1;
     }
   }

 if(redcomp!=1)
  printf("-1\n");

 for(i=1;i<=n;i++)
  for(j=i+1;j<=n;j++)
   if(bc[i]!=bc[j])
   {
    g[i][j]^=1;
    g[j][i]^=1;

    Clear();
    cnt=0;
     for(z=1;z<=n;z++)
      if(!used[z])
      {
       cnt++;
       DFS(z,0);
      }

     if(cnt==redcomp)
     {
      ans.push_back(make_pair(i,j));
      bluecomp--;
      cc=bc[j];
       for(z=1;z<=n;z++)
        if(bc[z]==cc)
         bc[z]=bc[i];
     }
     else
     {
      g[i][j]^=1;
      g[j][i]^=1;
     }
   }

  if(redcomp!=1 && bluecomp!=1)
   printf("-1\n");

sz=ans.size();

printf("%d\n",sz);
  for(i=0;i<sz;i++)
   printf("%d %d\n",ans[i].first,ans[i].second);

return 0;
}
