/**
* user:  А1105
* fname: Венелин Мирославов Пендев
* lname: Бургас
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 11:55:27.432450
*/
#include<iostream>
#include<queue>
#define MAXN 251
using namespace std;

int graph[MAXN][MAXN];
int n, a, b, x, y;
bool used[251];
queue <int> q;

void clearUsed(){
     for(int i=0; i<=n; i++){
          used[i]=0;
     }
}

void bfs1(int v){//sini
     x=1;
     used[v]=1;
     q.push(v);
     while(!q.empty()){
          int top=q.front();
          for(int i=1; i<=n; i++){
               if(graph[top][i]==1 && used[i]==0){
                    //cout<<i<<"  ";
                    used[i]=1;
                    q.push(i);
               }
          }
          q.pop();
     }
     for(int i=1; i<=n; i++){
          if (used[i]==0){
               x=0;
          }
     }
}

void bfs2(int v){ //cherveni
     y=1;
     used[v]=1;
     q.push(v);
     while(!q.empty()){
          int top=q.front();
          for(int i=1; i<=n; i++){
               if(graph[top][i]==0 && used[i]==0){
                    //cout<<i<<"  ";
                    used[i]=1;
                    q.push(i);
               }
          }
          q.pop();
     }
     for(int i=1; i<=n; i++){
          if (used[i]==0){
               y=0;
          }
     }
}

void printGraph(){
     for(int i=1; i<=n; i++){
          for(int j=1; j<=n; j++){
               cout<<graph[i][j];
          }
          cout<<endl;
     }
}

int main(){
     cin>>n;
     for(int i=1; i<=n; i++){
          for(int j=1; j<=n; j++){
               cin>>graph[i][j];
          }
     }
     cin>>a>>b;
     int br1=0;
     int br2=0;
     for(int i=1; i<=n; i++){
          if(used[i]==0){
               bfs1(i);br1++;
          }
     }
     clearUsed();
     for(int i=1; i<=n; i++){
          if(used[i]==0){
               bfs2(i);br2++;
          }
     }
     /*cout<<"a="<<a<<endl;
     cout<<"y="<<y<<endl;
     cout<<"b="<<b<<endl;
     cout<<"x="<<x<<endl;
     cout<<br1<<" "<<br2<<endl;*/
     if(br1==1 && br2==1 && b==x && a==y){
          cout<<0<<endl;
          return 0;
     }
     if(a==0 && y==0){
          if(b==1)
               if(br1==1 && b==x) {cout<<0<<endl; return 0;}
          else if(b==0 && br1>1) {cout<<0<<endl; return 0;}
     }
     if(b==0 && x==0){
          if(a==1)
               if(br2==1 && a==y) {cout<<0<<endl; return 0;}
          else if(a==0 && br2>1) {cout<<0<<endl; return 0;}
     }
     if(a==1 && y==1 && br2==1) {cout<<0<<endl; return 0;}
     if(b==1 && x==1 && br1==1) {cout<<0<<endl; return 0;}
 /*    if(x==0){
          cout<<"br1="<<br1<<" x = "<<x<<endl;for(int i=1; i<=n; i++){
               for(int j=i+1; j<=n; j++){
                    if(graph[i][j]==0){
                         graph[i][j]=1;
                         graph[j][i]=1;
                         for(int i=1; i<=n; i++){
                              if(used[i]==0){
                                   bfs1(i);br1++;
                              }
                         }
                         clearUsed();

                         if(br1==1 && b==x){
                              cout<<1<<endl;
                              cout<<i<<j<<endl;
                              return 0;
                         }
                         graph[i][j]=0;
                         graph[j][i]=0;
                    }
               }
          }
     }
*/
     /*else if(b!=x && a==y){
          if(x==0){
               for(int i=1; i<=n; i++){
                    for(int j=i+1; j<=n; j++){
                         x=1;
                         y=1;
                         //cout<<"graph["<<i<<"]["<<j<<"]= "<<graph[i][j]<<endl;
                         if(graph[i][j]==0){
                              graph[i][j]=1;
                              graph[j][i]=1;
                              //printGraph();
                              bfs1(1);
                              clearUsed();
                              bfs2(1);
                              clearUsed();
                              if(x==b && a==y){
                                   cout<<1<<endl;
                                   return 0;
                              }
                         }
                    }
               }
          }
          if(x==1){
               for(int i=1; i<=n; i++){
                    for(int j=i+1; j<=n; j++){
                         x=1;
                         y=1;
                         //cout<<"graph["<<i<<"]["<<j<<"]= "<<graph[i][j]<<endl;
                         if(graph[i][j]==1){
                              graph[i][j]=0;
                              graph[j][i]=0;
                              //printGraph();
                              bfs1(1);
                              clearUsed();
                              bfs2(1);
                              clearUsed();
                              if(x==b && a==y){
                                   cout<<1<<endl;
                                   return 0;
                              }
                         }
                    }
               }
          }
     }
     else if(a!=y){
          if(y==0){
               for(int i=1; i<=n; i++){
                    for(int j=i+1; j<=n; j++){
                         x=1;
                         y=1;
                         //cout<<"graph["<<i<<"]["<<j<<"]= "<<graph[i][j]<<endl;
                         if(graph[i][j]==1){
                              graph[i][j]=0;
                              graph[j][i]=0;
                              //printGraph();
                              bfs2(1);
                              clearUsed();
                              bfs1(1);
                              clearUsed();
                              if(y==a && x==b){
                                   cout<<1<<endl;
                                   return 0;
                              }
                         }
                    }
               }
          }
          if(y==1){
               for(int i=1; i<=n; i++){
                    for(int j=i+1; j<=n; j++){
                         x=1;
                         y=1;
                         //cout<<"graph["<<i<<"]["<<j<<"]= "<<graph[i][j]<<endl;
                         if(graph[i][j]==0){
                              graph[i][j]=1;
                              graph[j][i]=1;
                              //printGraph();
                              bfs2(1);
                              clearUsed();
                              bfs1(1);
                              clearUsed();
                              if(y==a && x==b){
                                   cout<<1<<endl;
                                   return 0;
                              }
                         }
                    }
               }
          }

     }*/
     else cout<<-1<<endl;
     return 0;
}
