/**
* user:  А1106
* fname: Георги Стоянов Шавов
* lname: Бургас
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 10:05:13.013817
*/
#include<iostream>
#include<vector>
#include<queue>
#define MAX 254
using namespace std;
vector<vector<pair<int,int> > >graph;
vector<pair<int,int> >ans;
vector<int>usedR,usedB;
int n,x,y;
bool flag;

void BFS(int v){
    usedR[v]=1;
    usedB[v]=1;
    queue<int>q;
    q.push(v);
    while(!q.empty()){
        int top=q.front();
        for(int i=0;i<graph[top].size();i++){
            if(usedR[graph[top][i].first] == 0 && graph[top][i].second==0){
                usedR[graph[top][i].first] = 1;
                q.push(graph[top][i].first);
            }
            if(usedB[graph[top][i].first] == 0 && graph[top][i].second==1){
                usedB[graph[top][i].first] = 1;
                q.push(graph[top][i].first);
            }
        }
        q.pop();
    }
}

int main(){
    cin>>n;
    graph.resize(n+1);
    usedR.resize(n+1);
    usedB.resize(n+1);
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            cin>>x;
            if(x==0 && i!=j && i<j){
                graph[i].push_back(make_pair(j,x));
                graph[j].push_back(make_pair(i,x));
            }else if(x==1 && i!=j && i<j){
                graph[i].push_back(make_pair(j,x));
                graph[j].push_back(make_pair(i,x));
            }
        }
    }
    cin>>x>>y;
    if(x==1 && y==1){
        BFS(1);
        for(int i=0;i<n;i++){
            if(usedR[i]==0){
                if(graph[i].size()==0){
                        cout<<-1<<endl;
                        return 0;
                }
                for(int j=0;j<graph[i].size();j++){
                    if(usedR[graph[i][j].first]==1){
                        graph[i][j].second=0;
                        graph[graph[i][j].first][i].second=0;
                        ans.push_back(make_pair(i,graph[i][j].first));
                        usedR[i]=1;
                        flag=1;
                        break;
                    }
                }
                if(flag==0){
                        graph[i][0].second=0;
                        graph[graph[i][0].first][i].second=0;
                        ans.push_back(make_pair(i,graph[i][0].first));
                        usedR[i]=1;
                    }
                flag=0;
            }
            if(usedB[i]==0){
                if(graph[i].size()==0){
                        cout<<-1<<endl;
                        return 0;
                }
                for(int j=0;j<graph[i].size();j++){
                    if(usedB[graph[i][j].first]==1){
                        graph[i][j].second=1;
                        graph[graph[i][j].first][i].second=1;
                        ans.push_back(make_pair(i,graph[i][j].first));
                        usedB[i]=1;
                        flag=1;
                        break;
                    }
                }
                if(flag==0){
                        graph[i][0].second=1;
                        graph[graph[i][0].first][i].second=1;
                        ans.push_back(make_pair(i,graph[i][0].first));
                        usedB[i]=1;
                    }
                flag=0;
            }
        }
        usedR.clear();
        usedB.clear();
        BFS(1);
        for(int i=0;i<n;i++){
            if(usedR[i]==0 || usedB[i]==0){
                cout<<-1<<endl;
                return 0;
            }
        }
        if(ans.size()==0){
            cout<<ans.size()<<endl;
            return 0;
        }
        cout<<ans.size()<<endl;
        for(int i=0;i<ans.size();i++){
            cout<<ans[i].first+1<<" "<<ans[i].second+1<<endl;
        }
        return 0;
    }
    if(x==0 && y==1){
        BFS(1);
        for(int i=0;i<n;i++){
            if(usedB[i]==0){
                if(graph[i].size()==0){
                        cout<<-1<<endl;
                        return 0;
                }
                for(int j=0;j<graph[i].size();j++){
                    if(usedB[graph[i][j].first]==1){
                        graph[i][j].second=1;
                        graph[graph[i][j].first][i].second=1;
                        ans.push_back(make_pair(i,graph[i][j].first));
                        usedB[i]=1;
                        flag=1;
                        break;
                    }
                }
                if(flag==0){
                        graph[i][0].second=1;
                        graph[graph[i][0].first][i].second=1;
                        ans.push_back(make_pair(i,graph[i][0].first));
                        usedB[i]=1;
                    }
                flag=0;
            }
        }
        usedR.clear();
        usedB.clear();
        BFS(1);
        for(int i=0;i<n;i++){
            if(usedB[i]==0){
                cout<<-1<<endl;
                return 0;
            }
        }
        if(ans.size()==0){
            cout<<ans.size()<<endl;
            return 0;
        }
        cout<<ans.size()<<endl;
        for(int i=0;i<ans.size();i++){
            cout<<ans[i].first+1<<" "<<ans[i].second+1<<endl;
        }
        return 0;
    }
    if(x==1 && y==0){
        BFS(1);
        for(int i=0;i<n;i++){
            if(usedR[i]==0){
                if(graph[i].size()==0){
                        cout<<-1<<endl;
                        return 0;
                }
                for(int j=0;j<graph[i].size();j++){
                    if(usedR[graph[i][j].first]==1){
                        graph[i][j].second=0;
                        graph[graph[i][j].first][i].second=0;
                        ans.push_back(make_pair(i,graph[i][j].first));
                        usedR[i]=1;
                        flag=1;
                        break;
                    }
                }
                if(flag==0){
                        graph[i][0].second=0;
                        graph[graph[i][0].first][i].second=0;
                        ans.push_back(make_pair(i,graph[i][0].first));
                        usedR[i]=1;
                    }
                flag=0;
            }
        }
        usedR.clear();
        usedB.clear();
        BFS(1);
        for(int i=0;i<n;i++){
            if(usedR[i]==0){
                cout<<-1<<endl;
                return 0;
            }
        }
        if(ans.size()==0){
            cout<<ans.size()<<endl;
            return 0;
        }
        cout<<ans.size()<<endl;
        for(int i=0;i<ans.size();i++){
            cout<<ans[i].first+1<<" "<<ans[i].second+1<<endl;
        }
        return 0;
    }
    return 0;
}
