/**
* user:  А1108
* fname: Марк Николаев Драгнев
* lname: Варна
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 10:39:59.842794
*/
#include <iostream>
#include <cstdio>
#define MAXN 251

using namespace std;

int n;
int A, B;
bool used[MAXN], used1[MAXN];
int isFullRed, isFullBlue;
int red[MAXN][MAXN], blue[MAXN][MAXN];

void input() {
    int a;
    cin >> n;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a;
            if (i == j) continue;
            if (a == 0) red[i][j] = 1;
            else blue[i][j] = 1;
        }
    }

    cin >> A >> B;
}

void DFSr(int start) {
    used[start] = 1;
    isFullRed++;

    for (int i = 0; i < n; i++)
        if (red[start][i] && !used[i]) DFSr(i);
}

void DFSb(int start) {
    used1[start] = 1;
    isFullBlue++;

    for (int i = 0; i < n; i++)
        if (blue[start][i] && !used1[i]) DFSb(i);
}

int main() {
    input();
    DFSr(0);
    DFSb(0);

    int br = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {DFSr(i); br++;}
    }

    int br1 = 0;
    for (int i = 0; i < n; i++) {
        if (!used1[i]) {DFSb(i); br1++;}
    }

    bool ans = false, ans1 = false;
    if (br == 0) ans = true;
    if (br1 == 0) ans1 = true;
    if (ans == A && ans1 == B) {cout << "0\n"; return 0;}
    else cout << "-1\n";
    return 0;
}

/**

4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1
2
1 3
4 3

3
0 1 1
1 0 0
1 0 0
1 1
-1

3
0 1 1
1 0 0
1 0 0
0 1
0

*/
