/**
* user:  А1119
* fname: Иво Томас Зерков
* lname: София-град
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 12:19:16.604695
*/
#include<bits/stdc++.h>
#define N 251
using namespace std;

bool state(int graph[N][N],int n, bool c)
{
    int subtree[n];
    int root[n];
    bool checked[n];
    stack<int> tbc;
    for(int i = 0; i < n; i++)
    {
        subtree[i]=1;
        root[i]=i;
        checked[i]=0;
    }
    tbc.push(0);
    while(!tbc.empty())
    {
        int u=tbc.top();
        checked[u]=1;
        tbc.pop();
        for(int i = 0; i < n; i++)
        {
            if(graph[i][u]==c&&!checked[i])
            {tbc.push(i);
            if(subtree[i]>subtree[u]) {subtree[i]++; root[u]=root[i];}
            else {subtree[u]++; root[i]=root[u];}
            }
        }
    }
    for(int i = 0; i < n; i++)
        if(root[i]!=0) return 0;
    return (1);
}



int main ()
{
cin.tie(0);
ios_base::sync_with_stdio(0);

int n,u;
cin >> n;

int edges[N*N];
int graph[N][N];
int tgraph[N][N];
memset(graph,-1,sizeof graph);
memset(tgraph,-1,sizeof tgraph);

for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++)
    {
        cin >> u;
        graph[i][j]=u;
        tgraph[i][j]=u;
        edges[i*n+j]=graph[i][j];
    }

int b1,r1,b2,r2;
cin >> b2 >> r2;
if(r2==0&&b2==0||(n==3&&r2==1&&b2==1)){cout<<-1;return 0;}
b1=state(graph,n,0);
r1=state(graph,n,1);
if(b1==b2&&r1==r2){cout<<0;return 0;}
for(int i = 0; i < n*n; i++)
{
    tgraph[i%n][i/n]=1-tgraph[i%n][i/n];
    tgraph[i/n][i%n]=1-tgraph[i/n][i%n];
    b1=state(tgraph,n,0);
    r1=state(tgraph,n,1);
    if(b1==b2&&r1==r2){
    cout << 1 << endl;
    cout << i%n+1 << " " << i/n+1;
    return 0;
    }
    tgraph[i%n][i/n]=1-tgraph[i%n][i/n];
    tgraph[i/n][i%n]=1-tgraph[i/n][i%n];
}
for(int i = 0; i < n*n; i++)
{
    for(int j = i+1; j < n*n; j++)
    {
        tgraph[i%n][i/n]=1-tgraph[i%n][i/n];
        tgraph[i/n][i%n]=1-tgraph[i/n][i%n];
        tgraph[j%n][j/n]=1-tgraph[j%n][j/n];
        tgraph[j/n][j%n]=1-tgraph[j/n][j%n];
        b1=state(tgraph,n,0);
        r1=state(tgraph,n,1);
        if(b1==b2&&r1==r2){
        cout << 2 << endl;
        cout << i%n+1 << " " << i/n+1 << endl;
        cout << j%n+1 << " " << j/n+1 << endl;
        return 0;
        }
        tgraph[i%n][i/n]=1-tgraph[i%n][i/n];
        tgraph[i/n][i%n]=1-tgraph[i/n][i%n];
        tgraph[j%n][j/n]=1-tgraph[j%n][j/n];
        tgraph[j/n][j%n]=1-tgraph[j/n][j%n];
    }
}

for(int i = 0; i < n*n; i++)
{
    for(int j = i+1; j < n*n; j++)
    {
        for(int k = j+1; k<n*n; k++)
        {
            tgraph[i%n][i/n]=1-tgraph[i%n][i/n];
            tgraph[i/n][i%n]=1-tgraph[i/n][i%n];
            tgraph[j%n][j/n]=1-tgraph[j%n][j/n];
            tgraph[j/n][j%n]=1-tgraph[j/n][j%n];
            tgraph[k%n][k/n]=1-tgraph[k%n][k/n];
            tgraph[k/n][k%n]=1-tgraph[k/n][k%n];
            b1=state(tgraph,n,0);
            r1=state(tgraph,n,1);
            if(b1==b2&&r1==r2){
            cout << 3 << endl;
            cout << i%n+1 << " " << i/n+1 << endl;
            cout << j%n+1 << " " << j/n+1 << endl;
            cout << k%n+1 << " " << k/n+1 << endl;
            return 0;
            }
            tgraph[i%n][i/n]=1-tgraph[i%n][i/n];
            tgraph[i/n][i%n]=1-tgraph[i/n][i%n];
            tgraph[j%n][j/n]=1-tgraph[j%n][j/n];
            tgraph[j/n][j%n]=1-tgraph[j/n][j%n];
            tgraph[k%n][k/n]=1-tgraph[k%n][k/n];
            tgraph[k/n][k%n]=1-tgraph[k/n][k%n];
        }
    }
}
for(int i = 0; i < n*n; i++)
{
    for(int j = i+1; j < n*n; j++)
    {
        for(int k = j+1; k<n*n; k++)
        {
            for(int l = k+1; l<n*n;l++) {
            tgraph[i%n][i/n]=1-graph[i%n][i/n];
            tgraph[i/n][i%n]=1-graph[i/n][i%n];
            tgraph[l%n][l/n]=1-graph[l%n][l/n];
            tgraph[l/n][l%n]=1-graph[l/n][l%n];
            tgraph[j%n][j/n]=1-graph[j%n][j/n];
            tgraph[j/n][j%n]=1-graph[j/n][j%n];
            tgraph[k%n][k/n]=1-graph[k%n][k/n];
            tgraph[k/n][k%n]=1-graph[k/n][k%n];
            b1=state(tgraph,n,0);
            r1=state(tgraph,n,1);
            if(b1==b2&&r1==r2){
            cout << 4 << endl;
            cout << i%n+1 << " " << i/n+1 << endl;
            cout << j%n+1 << " " << j/n+1 << endl;
            cout << k%n+1 << " " << k/n+1 << endl;
            cout << l%n+1 << " " << l/n+1 << endl;
            return 0;
            }
            tgraph[i%n][i/n]=1-graph[i%n][i/n];
            tgraph[i/n][i%n]=1-graph[i/n][i%n];
            tgraph[l%n][l/n]=1-graph[l%n][l/n];
            tgraph[l/n][l%n]=1-graph[l/n][l%n];
            tgraph[j%n][j/n]=1-graph[j%n][j/n];
            tgraph[j/n][j%n]=1-graph[j/n][j%n];
            tgraph[k%n][k/n]=1-graph[k%n][k/n];
            tgraph[k/n][k%n]=1-graph[k/n][k%n];
            }
        }
    }
}
cout << -1; return 0;

}
/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1
*/

