/**
* user:  А1120
* fname: Камен Валентинов Павлов
* lname: София-град
* task:  colorgraph
* score: 10.0
* date:  2017-11-25 12:33:07.727763
*/
#include <iostream>
#include <set>
#include <stack>
#include <utility>

using namespace std;

int n, mini = 99999;
set <int> gr[251];
stack <pair <int, int> > izh, maybe;
bool a[2], g[251][251], used[251], usedp[251][251];

void anul() {
    used[0] = true;
    for(int i = 1; i < n; i ++) {
        used[i] = false;
    }
}

void equate(stack <pair <int, int> > &q, stack <pair <int, int> > w) {
    while(!q.empty()) {
        q.pop();
    }
    while(!w.empty()) {
        q.push(w.top());
        w.pop();
    }
}

bool check(int x, bool y) {
    for(int i = 0; i < n; i ++) {
        if(!used[i] && gr[x].count(i) && g[x][i] == y) {
            used[i] = true;
            if(check(i, y)) return true;
        }
    }
    for(int i = 0; i < n; i ++) {
        if(!used[i]) return false;
    }
    return true;
}

void cycle(stack <pair <int, int> > &z) {
    bool red, blue;
    anul();
    red = check(0, 0);
    anul();
    blue = check(0, 1);
    if(red == a[0] && blue == a[1]) {
        if(z.size() < mini) {
            mini = z.size();
            equate(izh, z);
        }
        return;
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((g[i][j] && (!a[1] && blue || a[0] && !red) || !g[i][j] && (!a[0] && red || a[1] && !blue)) && !usedp[i][j]) {
                z.push({i, j});
                usedp[i][j] = true;
                g[i][j] = !g[i][j];
                g[j][i] = !g[j][i];
                cycle(z);
                g[i][j] = !g[i][j];
                g[j][i] = !g[j][i];
                z.pop();
                usedp[i][j] = false;
            }
        }
    }
}

int main() {
    cin >> n;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            cin >> g[i][j];
            g[j][i] = g[i][j];
            gr[i].insert(j);
            gr[j].insert(i);
        }
    }
    cin >> a[0] >> a[1];
    cycle(maybe);
    if(mini == 99999) {
        cout << -1 << endl;
        return 0;
    }
    if(mini == 0) {
        cout << 0 << endl;
        return 0;
    }
    cout << mini << endl;
    while(!izh.empty()) {
        cout << izh.top().first + 1 << " " << izh.top().second + 1 << endl;
        izh.pop();
    }
    return 0;
}
