/**
* user:  А1121
* fname: Иван Даниелов Иванов
* lname: София-град
* task:  colorgraph
* score: 15.0
* date:  2017-11-25 11:29:46.501953
*/
#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
int input[8][8],n,revnum[8][8];
bool used[8];
void dfs(int v,int state,int type){
	used[v]=true;
	for(int i=0;i<n;i++){
		int nval=input[v][i];
		if(state&(1<<revnum[i][v])){
			nval^=1;
		}
		if(!used[i]&&nval==type){
			dfs(i,state,type);
		}
	}
}
int main(){
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	cin>>n;
	for(int i=0;i<n;i++){
		for(int j=0;j<n;j++){
			cin>>input[i][j];
		}
	}
	int br=0;
	for(int i=0;i<n;i++){
		for(int j=i+1;j<n;j++){
			revnum[i][j]=br;
			revnum[j][i]=br++;
		}
	}
	int stateRed,stateBlue,minx=br+1,minState=0;
	cin>>stateRed>>stateBlue;
	for(int j=0;j<(1<<br);j++){
		dfs(0,j,0);
		int visitedRed=0;
		for(int i=0;i<n;i++){
			visitedRed+=used[i];
			used[i]=false;
		}
		dfs(0,j,1);
		int visitedBlue=0;
		for(int i=0;i<n;i++){
			visitedBlue+=used[i];
			used[i]=false;
		}
		if(((visitedRed!=n&&!stateRed)||(visitedRed==n&&stateRed))&&((visitedBlue!=n&&!stateBlue)||(visitedBlue==n&&stateBlue))){
			int cnt=0,pom=j;
			while(pom!=0){
				cnt+=pom%2;
				pom/=2;
			}
			if(minx>cnt){
				minx=cnt;
				minState=j;
			}
		}
	}
	if(minx==br+1){
		cout<<"-1\n";
		return 0;
	}
	cout<<minx<<"\n";
	for(int a=0;a<n;a++){
		for(int b=a+1;b<n;b++){
			if(minState&(1<<revnum[a][b])){
				cout<<a+1<<" "<<b+1<<"\n";
			}
		}
	}
	return 0;
}
