/**
* user:  А1125
* fname: Станимир Стефанов Петров
* lname: Стара Загора
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 12:41:15.376324
*/
#include <iostream>
#include <vector>
using namespace std;

int Graph[10][10];

void inp(int n)
{
    int t;
    for(int i=0; i<n; ++i)
        for(int j=0; j<n; ++j)
        {
            cin >> t;
            Graph[i][j]=t;
            Graph[j][i]=t;
        }
}

vector<bool> f;

void DFS(int n, int c, int st=0)
{
    if(f[st]) return;
    f[st]=true;
    for(int i=0; i<n; ++i)
        if(Graph[st][i]==c) DFS(n,c,i);
}


bool checkGraph(int n, int a, int b)
{
    int A=1,B=1;
    f.resize(n);
    DFS(n,0);
    for(bool x: f) if(!x) A=0;
    f=vector<bool>(n);
    DFS(n,1);
    for(bool x: f) if(!x) B=0;
    return A==a && B==b;
}

void init(int* a, int n)
{
    for(int i=0; i<n; ++i) a[i]=i+1;
}

bool nextComb(int* a, int n, int k)
{
    for(int i=k-1; i>=0; --i)
        if(a[i]<n-k+i+1)
        {
            ++a[i];
            for(++i; i<k; ++i) a[i]=a[i-1]+1;
            return true;
        }
    return false;
}

struct Node
{
    int from, to;
};

int main()
{
    int A[32];
    vector<Node> v;
    int n,a,b;
    cin >> n;
    inp(n);
    cin >> a >> b;
    if(checkGraph(n,a,b)) return (cout << 0 << endl), 0;
    init(A,2);
    do
        v.push_back(Node{A[0]-1,A[1]-1});
    while(nextComb(A,n,2));
    for(int i=1; i<=v.size(); ++i)
    {

        do
        {
            init(A,i);
            for(int j=0; j<i; ++j)
            {
                int x=A[j];
                Graph[v[x-1].from][v[x-1].to]=!Graph[v[x-1].from][v[x-1].to];
            }

            init(A,i);
            for(int j=0; j<i; ++j)
            {
                int x=A[j];
                Graph[v[x-1].from][v[x-1].to]=!Graph[v[x-1].from][v[x-1].to];
            }
        }
        while(nextComb(A,v.size(),i));
        if(checkGraph(n,a,b))
        {
            cout << i << endl;
for(int k=0; k<n; ++k)
{
    for(int l=0; l<n; ++l) cout << Graph[k][l] << ' ';
    cout << endl;
}

            init(A,i);
            do
                for(int j=0; j<i; ++j)
                {
                    int x=A[j];
                    cout << v[x-1].from+1 << ' ' << v[x-1].to+1 << endl;
                }
            while(nextComb(A,v.size(),i));
            return 0;
        }
        init(A,i);
        do
            for(int j=0; j<i; ++j)
            {
                int x=A[j];
                Graph[v[x-1].from][v[x-1].to]=!Graph[v[x-1].from][v[x-1].to];
            }
        while(nextComb(A,v.size(),i));
    }
    cout << -1 << endl;
}

/**
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1
*/
