/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  crypto
* score: 0.0
* date:  2017-11-25 09:55:34.523017
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MOD = (1e9) + 7;

int n,k,p;
unordered_map < int, int > state[407];

int recurse(int cnt, int code) {
    if(code<0) return 0;
    if(cnt==n) {
        if(code==0) return 1;
        return 0;
    }
    if(state[cnt].find(code)!=state[cnt].end()) return state[cnt][code];
    int ans=0,pos;
    for(pos=0;pos<=cnt;pos++) {
        int l=pos,r=cnt-pos;
        ans+=recurse(cnt+1,code-min(l,k-1)-min(r,k-1));
        ans%=MOD;
    }
    state[cnt][code]=ans;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    scanf("%d %d %d", &n, &k, &p);
   	int all=0;
    for(int len=k;len<=n;len++) {
        all+=n-len+1;
    }
    printf("%d\n", all);
    if(p>all) {
        printf("0\n");
        return 0;	    
    }    
    printf("%d\n", recurse(0,p));

    return 0;
}
