/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  crypto
* score: 5.0
* date:  2017-11-25 07:40:58.253128
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);
const int mod = (int)1e9 + 7;

int read_int();

int n, p, k;

void read()
{
    cin >> n >> k >> p;
}

void solve()
{
    int mx = 0;
    for(int i = 1; i <= n; i++)
        mx += min(0, i - k + 1);

    if(p > mx)
    {
        cout << 0 << endl;
        return;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

const int maxl = (1 << 18);
char buff[maxl];
int pos_buff = 0;

void next_char() { if(++pos_buff == maxl) fread(buff, 1, maxl, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0;
    bool is_neg = 0;

    for(; buff[pos_buff] < '0' || buff[pos_buff] > '9'; next_char()) is_neg |= (buff[pos_buff] == '-');
    for(; buff[pos_buff] >= '0' && buff[pos_buff] <= '9'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    if(is_neg) return -ret;
    return ret;
}

