/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  clubs
* score: 25.0
* date:  2017-11-25 12:30:24.431947
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
const int MAXN = (1 << 20);

int read_int();

int n;

void read()
{
    cin >> n;
}

int answer_1 = 0, answer_2 = 0;
vector<int> li[30];

//bool cmp(const vector<int> &x, const vector<int> &y) { return x.size() < y.size(); }
bool cmp(int i, int j) { return li[i].size() < li[j].size(); }

void solve(int n, int offset = 0)
{
    if(n == 1) return;

    int len = 0;
    for(; ((1 << len) < n); len++);
    if((1 << len) > n) len--;

    vector<int> perm;
    for(int i = 0; i < answer_1; i++) perm.push_back(i);
    sort(perm.begin(), perm.end(), cmp);

    for(int i = 0; i < (1 << len); i++)
        for(int j = 0; j < len; j++)
            if(i & (1 << j)) li[perm[j]].push_back(i + offset);

    for(int i = (1 << len); i < n; i++)
        li[perm[len]].push_back(i + offset);

    solve(n - (1 << len), offset + (1 << len));
}

void solve()
{
    for(; ((1 << answer_1) < n); answer_1++);

    if((1 << answer_1) == n)
    {
        for(int i = 0; i < answer_1; i++)
        {
            int cnt = 0;
            for(int p = 0; p < n; p++)
                if(p & (1 << i)) cnt++;
            chkmax(answer_2, cnt);
        }

        cout << answer_1 << " " << answer_2 << endl;
        for(int i = 0; i < answer_1; i++)
        {
            int cnt = 0;
            for(int p = 0; p < n; p++)
                if(p & (1 << i)) cnt++;

            cout << cnt << " ";
            for(int p = 0; p < n; p++)
                if(p & (1 << i)) cout << p << " ";
            cout << endl;
        }
    }
    else
    {
        solve(n, 1);

        for(int i = 0; i < answer_1; i++) chkmax(answer_2, li[i].size());
        cout << answer_1 << " " << answer_2 << endl;
        for(int i = 0; i < answer_1; i++)
        {
            cout << li[i].size() << " ";
            for(int x: li[i]) cout << x << " ";
            cout << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}

const int maxl = (1 << 18);
char buff[maxl];
int pos_buff = 0;

void next_char() { if(++pos_buff == maxl) fread(buff, 1, maxl, stdin), pos_buff = 0; }

int read_int()
{
    int ret = 0;
    bool is_neg = 0;

    for(; buff[pos_buff] < '0' || buff[pos_buff] > '9'; next_char()) is_neg |= (buff[pos_buff] == '-');
    for(; buff[pos_buff] >= '0' && buff[pos_buff] <= '9'; next_char())
        ret = ret * 10 + buff[pos_buff] - '0';

    if(is_neg) return -ret;
    return ret;
}

