/**
* user:  A1004
* fname: Viktor
* lname: Terziev
* task:  clubs
* score: 20.0
* date:  2017-11-25 10:14:27.941400
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <unordered_map>
#include <queue>
using namespace std;

int n, st = 0;
vector < int > cl[(1<<20)];
vector < pair < int, int  > > ans;
unordered_map < int, int > cntP[(1<<20)];

struct e {
    int pos, c0, c1;
    e ( int p_ = 0, int c0_ = 0, int c1_ = 0 ) {
        pos = p_;
        c0 = c0_;
        c1 = c1_;
    }

    const bool operator < ( const e &b ) const {
        return max( c0, c1 ) < max( b.c0 , b.c1 );
    }
};

priority_queue < e > q;

bool pos ( int maxSz ) {

    for ( int i = 0 ; i <= st ; i ++ ) {
        cntP[i].clear();
    }

    cntP[0][0] = n;

    for ( int i = 0 ; i < st ; i ++ ) {

        for ( auto it = cntP[i].begin()  ;it != cntP[i].end() ; it ++ ) {
            q.push( e( it->first, it->second, 0 ) );
        //    cout << it->first << " : " << it->second << " times\n";
        }
       // cout << "\n";

        for ( int ck = 0 ; ck < maxSz ; ck ++ ) {
            e crr = q.top(); q.pop();
            if ( crr.c0-1 >= crr.c1+1 ) { crr.c0 --; crr.c1 ++; }
            q.push( crr );
        }

        for ( ; !q.empty() ; ) {
            e crr = q.top(); q.pop();

            cntP[i+1][crr.pos*2] = crr.c0;
            cntP[i+1][crr.pos*2+1] = crr.c1;

        }

    }
   //cout << maxSz << "final\n";
    for ( auto it = cntP[st].begin() ; it != cntP[st].end() ; it ++ ) {
    //    cout << it->first << " : " << it->second << " times\n";
        if ( it->second > 1 ) { return 0; }
    }

    return 1;
}

int main () {
    cin >> n;
    for ( ; (1<<st) < n ; st ++ ) {}

    int l = max( 0, n/2-3000 ) , r = n/2+5, m = (l+r)/2;

    for ( ; l+1 < r ; m = (l+r)/2 ) {
        if ( !pos(m) ) {
            l = m;
        }else {
            r = m;
        }
    }
    pos(r);
    cout << st << " " << r <<  "\n";

     int h = 0 ;
     for ( auto it = cntP[st].begin() ; it != cntP[st].end() ; it ++ ) {
    //    cout << it->first << " : " << it->second << " times\n";
        if ( it->second == 1 ) {
            ans.push_back( make_pair( it->first, h+1 ) );
            h ++;
        }
    }

    for ( int i = 0 ; i < n ; i ++ ) {

        for ( int j = 0 ; j < st ; j ++ ) {
            if ( ans[i].first & (1<<j) ) { cl[j].push_back( ans[i].second ); }
        }
    }
    for ( int i = 0 ; i < st ; i ++ ) {
        cout << cl[i].size() << " ";
        for ( int j = 0 ; j < cl[i].size() ; j ++ ) {
            cout << cl[i][j] << " ";
        }
        cout << "\n";
    }
    return 0;

}
