/**
* user:  A1004
* fname: Viktor
* lname: Terziev
* task:  crypto
* score: 20.0
* date:  2017-11-25 11:39:02.455150
*/
#include <iostream>
#include <algorithm>
using namespace std;
int n, k, p;

int fact ( int x ) {
    return x == 0 ? 1 : x*fact(x-1);
}
int getCnt ( int x, int l ) {
    int sInd = max( 0 , x-k+1 ), fInd = min( l+1, x+k );
    return fInd - sInd -k+1;
}

int dp[/*N*/512][/*P*/2024];

int main () {

    cin >> n >> k >> p;

    dp[k][1] = fact(k);
    for ( int i = k ; i <= n ; i ++ ) {
        for ( int cp = 1; cp < n*n ; cp ++ ) {
            for ( int s = 0; s <= i ; s ++ ) {
                dp[i+1][ cp+getCnt(s, i) ] += dp[i][cp];
            }
        }
    }
    cout << dp[n][p] << "\n";

    return 0;
}

