/**
* user:  A1004
* fname: Viktor
* lname: Terziev
* task:  crypto
* score: 50.0
* date:  2017-11-25 12:11:13.108071
*/
#include <iostream>
#include <algorithm>
using namespace std;
int n, k, p;
long long dp[/*N*/512][/*P*/20024], mod = 1000000007;

long long fact ( int x ) {
    return x == 0 ? 1 : x*fact(x-1)%mod;
}
long long getCnt ( int x, int l ) {
    int sInd = max( 0 , x-k+1 ), fInd = min( l+1, x+k );
    return fInd - sInd -k+1;
}


int main () {

    cin >> n >> k >> p;

    int maxx = 0;

    dp[k][1] = fact(k);

    for ( int i = k ; i <= n ; i ++ ) {

        for ( int cp = 1 ; cp <= (n-k+1)*k; cp ++ ) {

            for ( int s = 0; s <= i ; s ++ ) {
                dp[i+1][ cp+getCnt(s, i) ] += dp[i][cp];

                if ( dp[i+1][ cp+getCnt(s, i) ] >= mod ){
                    dp[i+1][ cp+getCnt(s, i) ] -= mod;
                }
            }
        }

    }
//    cout << maxx << "\n";

    cout << dp[n][p] << "\n";

    return 0;
}

