/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  crypto
* score: 5.0
* date:  2017-11-25 10:05:54.487380
*/
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
#include <set>
using namespace std;

vector<int> get_primes()
{
    vector<int> primes;
    vector<bool> isPrime(1000000, true);
    isPrime[0]=isPrime[1]=false;
    for(int i=2;i<isPrime.size();i++)if(isPrime[i])
    {
        primes.push_back(i);
        for(int j=2*i;j<isPrime.size();j+=i)
        {
            isPrime[j]=false;
        }
    }
    return std::move(primes);
}

vector<int> primes=get_primes();
int n, k, p;

void solve()
{
    int answer=0;
    vector<int> seq(n);
    for(int i=0;i<n;i++)seq[i]=primes[i];

    do
    {
        //for(int x : seq)printf("%d ", x);
        //putchar('\n');
        set<int> uniqueProducts;

        for(int len=k;len<=n;len++)
        {
            for(int i=0;i+len<=n;i++)
            {
                int product=1;
                set<int> smallest;
                //putchar('{');
                for(int j=0;j<len;j++)
                {
                    //printf("%d", seq[i+j]);
                    //if(j<len-1)putchar(' ');
                    smallest.insert(seq[i+j]);
                }
                //printf("} ->", product);

                int z=0;for(int x : smallest)
                {
                    if(z==k)break;

                    product*=x;

                    z++;
                }

                //printf("%d ", product);
                uniqueProducts.insert(product);
            }
        }
        //putchar('\n');

        if(uniqueProducts.size()==p)answer++;
    }while(next_permutation(seq.begin(), seq.end()));

    printf("%d\n", answer);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>k>>p;
    solve();
}
