/**
* user:  A1005
* fname: Aleksandar
* lname: Ivanov
* task:  clubs
* score: 0.0
* date:  2017-11-25 12:21:13.845112
*/
#include <bits/stdc++.h>
using namespace std;

int club_count(int n)
{
    //lowest number of clubs where there are at least N differtent
    //bit masks of size(CLUB_COUNT)
    for(int i=1;;i++)
    {
        if((1<<i)>=n)return i;
    }
}

int n, clubCount;

int one_count(int mask)
{
    if(mask==0)return 0;

    int res=0;
    for(int i=0;i<clubCount;i++)
    {
        if((mask & (1<<i))!=0)res++;
    }
    return res;
}

bool s1(int x, int y)
{
    int c1=one_count(x);
    int c2=one_count(y);
    return c1<c2;
}

bool s2(int x, int y)
{
    int c1=one_count(x);
    int c2=one_count(y);
    return c1<c2 || (c1==c2 && (x&1)<(y&1) || ((x&1==y&1)&&x<y));
}

bool s3(int x, int y)
{
    int c1=one_count(x);
    int c2=one_count(y);
    return c1<c2 || (c1==c2&&x<y);
}

void print_mask(int mask)
{
    for(int i=0;i<clubCount;i++)
    {
        printf("%d ", (int)((1<<i)&mask)!=0);
    }
    putchar('\n');
}

vector<vector<int>> solve(function<bool(int, int)> sorter, bool printClubs=true)
{
    vector<int> possibleMasks;
    for(int i=0, c=1<<clubCount;i<c;i++)
    {
        possibleMasks.push_back(i);
    }

    sort(possibleMasks.begin(), possibleMasks.end(), sorter);

    //for(int x : possibleMasks)print_mask(x);

    int maxLen=0;
    vector<vector<int>> clubs;

    for(int i=0;i<n;i++)
    {
        int mask = possibleMasks[i];
        for(int club=0;club<clubCount;club++)
        {
            if((mask & (1<<club))!=0)
            {
                if(club>=clubs.size())clubs.resize(club+1);
                clubs[club].push_back(i+1);
                maxLen=max(maxLen, (int)clubs[club].size());
            }
        }
    }

    vector<vector<int>> solution;

    //printf("%d %d\n", clubCount, maxLen);
    solution.push_back({clubCount, maxLen});
    if(printClubs)for(auto &c : clubs)
    {
        solution.push_back(c);
    }

    return std::move(solution);
}

int main()
{
    cin>>n;
    clubCount=club_count(n);

    vector<vector<vector<int>>>sols{
        solve(s1), solve(s2), solve(s3)
    };

    int minClubSize=INT_MAX;
    int bestSolI=2;

    int solI=0;
    for(auto &sol : sols)
    {
        if(sol[0][1]<minClubSize)
        {
            minClubSize=sol[0][1];
            bestSolI=solI;
        }

        solI++;
    }

    for(auto &x : sols[bestSolI])
    {
        for(int y : x)printf("%d ", y);
        putchar('\n');
    }


    return 0;
    solve(s1, false);
    solve(s2, false);
    solve(s3, false);
}
