/**
* user:  A1006
* fname: Ilia
* lname: Bozhinov
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 11:15:04.441371
*/
#include <iostream>
#define debug(x) #x << " = " << (x)
#define _ << " " <<


const int maxn = 250;
int n;
int mat[maxn][maxn];

int mark[maxn][2];
int coldeg[maxn][2];

void dfs(int x, int color)
{
    mark[x][color] = 1;

    for (int y = 0; y < n; y++)
    {
        if (x == y || mark[y][color] || mat[x][y] != color) continue;
        dfs(y, color);
    }
}

int main()
{
    std::cin >> n;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            std::cin >> mat[i][j];
            coldeg[i][mat[i][j]]++;
        }
    }


    int sum = 0;

    bool h[2] = {false, false};
    for (int c = 0; c <= 1; c++)
    {
        for (int i = 0; i < n; i++)
        {
            if (coldeg[i][c] == n - 1) 
                h[c] = 1;

        //    std::cout << debug(i) + 1 _ debug(c) _ coldeg[i][c] << std::endl;
            if (!mark[i][c])
            {
        //        std::cout << i << " " << c << std::endl;
                dfs(i, c);
                sum++;
            }
        }

   //     std::cout << sum << std::endl;
    }



    if (n == 3)
        std::cout << -1 << std::endl;
    else {
        if (h[0] ^ h[1])
            std::cout << sum - 1 << std::endl;
        else 
            std::cout << sum - 2 << std::endl;
    }
    return 0;
}



