/**
* user:  A1007
* fname: Ivan
* lname: Ganev
* task:  clubs
* score: 35.0
* date:  2017-11-25 11:45:56.766456
*/
# include <cstdio>
# include <vector>

using namespace std;

const int MAX_L = 19;


int n, k;
int lim;
vector <int> v[MAX_L];

bool go (int lvl, int l, int r)
{
	if (lvl == k)
	{
		if (l < r)
			return false;
		return true;
	}
	
	
	int mid = (l + r) >> 1, i;
	for (i = r; i >= mid + 1 && v[lvl].size () < lim; i --)
		v[lvl].push_back (i);

	if (l < i)
		if (!go (lvl + 1, l, i))
			return false;
	if ((i + 1) <= r)
		if (!go (lvl + 1, i + 1, r))
			return false;
	return true;
}

int main ()
{
	int i, j, s, len = 0;
	scanf ("%d", &n);

	for (k = 1; (1 << k) < n; k ++);
	
	int l, r, mid;
	l = 0;
	r = n + 1;
	while (r - l > 1)
	{
		mid = (l + r) >> 1;
		lim = mid;
		if (go (0, 1, n))
			r = mid;
		else
			l = mid;
		for (i = 0; i <= k; i ++)
			v[i].clear ();
	}
	lim = r;
	go (0, 1, n);
	for (i = 0; i < 19; i ++)
		if (!v[i].size ())
			break;
		else
			if (len < v[i].size ())
				len = v[i].size ();
	k = i;
	printf ("%d %d\n", k, len);
	
	for (i = 0; i < k; i ++)
	{
		printf ("%d", (int) v[i].size ());
		for (j = 0; j < (int) v[i].size (); j ++)
			printf (" %d", v[i][j]);
		printf ("\n");
	}
	return 0;
}

