/**
* user:  A1009
* fname: Adriyan
* lname: Ibovski
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 08:25:46.896663
*/
# include<iostream>
# include<algorithm>
# include<vector>
# include<utility>
using namespace std;

int a[256][256];
int parent[256];
int sz[1024];
void create(int x)
{
    parent[x]=x;
    sz[x]=1;
}

int find_set(int x)
{
    //cout<<x<<endl;
    if(parent[x]==x) return x;
    return parent[x]=find_set(parent[x]);
}

void connect_set(int x, int y)
{
    x=find_set(x); y=find_set(y);
    if(x!=y)
    {
        if(sz[x]<sz[y]) swap(x,y);;
        parent[y]=x;
        sz[x]+=sz[y];
    }

}
int red,blue;
int r[256][256],b[256][256];
vector<pair<int,int> > ans;
vector<int> g[256];
bool vis[256];
int br=0;
void dfs(int u)
{
    vis[u]=1;
    br++;
    for(int i=0; i<g[u].size(); i++)
    {
        if(!vis[g[u][i]] && b[u][g[u][i]]==0)
            dfs(g[u][i]);
    }
}
int firstb,firstr;
int main()
{
    int n;
    cin>>n;
    for(int i=0; i<=n; i++) create(i);
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            cin>>a[i][j];
            if(i!=j)
            {
                if(a[i][j]==1)
                {
                    if(find_set(i)!=find_set(j))
                    {
                        if(!firstb) firstb=i;
                        connect_set(i,j);
                        b[i][j]=1;
                        b[j][i]=1;
                    }
                    else if(!b[i][j])
                        {
                            blue++;
                            b[i][j]=1;
                            b[j][i]=1;
                        }
                }
                else
                {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
               /* else
                {
                     if(find_set(i)!=find_set(j))
                    {
                        if(!firstr) firstr=i;
                        connect_set(i,j);
                        r[i][j]=1;
                        r[j][i]=1;
                    }
                    else if(!r[i][j])
                        {
                            red++;
                            r[i][j]=1;
                            r[j][i]=1;
                        }
                }*/
            }
        }
    }
    int A,B;
    cin>>A>>B;
    bool fb=true;
    for(int i=1; i<=n; i++)
    {
        if(find_set(firstb)!=find_set(i)) fb=false;
    }
    if(B==1)
    {
        if(!fb)
        {
            for(int i=1; i<=n; i++)
            {
                if(find_set(firstb)!=find_set(i))
                {
                    b[firstb][i]=1;
                    b[i][firstb]=1;
                    ans.push_back(make_pair(firstb,i));
                }
            }
        }
        dfs(firstr);
        if(br<n && A==1) cout<<-1<<endl;
        else
        {
            cout<<ans.size()<<endl;
            for(int i=0; i<ans.size(); i++)
                cout<<ans[i].first<<" "<<ans[i].second<<endl;
        }
    }
}
/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

3
0 1 1
1 0 0
1 0 0
1 1

3
0 1 1
1 0 0
1 0 0
0 1

5
0 1 0 0 0
1 0 0 0 1
0 0 0 1 1
0 0 1 0 1
0 1 1 1 0
1 1
*/
