/**
* user:  A1009
* fname: Adriyan
* lname: Ibovski
* task:  colorgraph
* score: 20.0
* date:  2017-11-25 10:38:34.947389
*/
# include<iostream>
# include<algorithm>
# include<vector>
# include<utility>
# include<fstream>
using namespace std;

ifstream fin("123.out");

int a[256][256];
int parent[256],parent1[256];
int sz[1024],sz1[256];
void create(int x)
{
    parent[x]=x;
    sz[x]=1;
}

int find_set(int x)
{
    //cout<<x<<endl;
    if(parent[x]==x) return x;
    return parent[x]=find_set(parent[x]);
}

void connect_set(int x, int y)
{
    x=find_set(x); y=find_set(y);
    if(x!=y)
    {
        if(sz[x]<sz[y]) swap(x,y);;
        parent[y]=x;
        sz[x]+=sz[y];
    }

}
void create1(int x)
{
    parent1[x]=x;
    sz1[x]=1;
}

int find_set1(int x)
{
    //cout<<x<<endl;
    if(parent1[x]==x) return x;
    return parent1[x]=find_set1(parent1[x]);
}

void connect_set1(int x, int y)
{
    x=find_set1(x); y=find_set1(y);
    if(x!=y)
    {
        if(sz1[x]<sz1[y]) swap(x,y);;
        parent1[y]=x;
        sz1[x]+=sz1[y];
    }

}
int red,blue;
int r[256][256],b[256][256];
vector<pair<int,int> > ans;
int firstb=1,firstr=1;
int main()
{
    int n;
    cin>>n;
    for(int i=0; i<=n; i++) {create(i); create1(i);}
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            cin>>a[i][j];
            if(i!=j)
            {
                if(a[i][j]==1)
                {
                    if(find_set(i)!=find_set(j))
                    {
                        firstb=i;
                        connect_set(i,j);
                        b[i][j]=1;
                        b[j][i]=1;
                    }
                    else if(!b[i][j])
                        {
                            blue++;
                            b[i][j]=1;
                            b[j][i]=1;
                        }
                }
                else
                {
                     if(find_set1(i)!=find_set1(j))
                    {
                        firstr=i;
                        connect_set1(i,j);
                        r[i][j]=1;
                        r[j][i]=1;
                    }
                    else if(!r[i][j])
                        {
                            red++;
                            r[i][j]=1;
                            r[j][i]=1;
                        }
                }
            }
        }
    }
    int A,B;
    cin>>A>>B;
    bool fb=true,fr;
    for(int i=1; i<=n; i++)
    {
        if(find_set(firstb)!=find_set(i)) fb=false;
    }
    int brr=0,minbr=n,c=0;
    if(B==1)
    {
        if(!fb)
        {
            for(int j=1; j<=n; j++)
            {
                for(int i=1; i<=n; i++)
                {
                  //  cout<<i<<" "<<j<<" "<<br<<endl;
                    if(find_set(j)!=find_set(i))
                    {
                        connect_set(j,i);
                        ans.push_back(make_pair(j,i));
                        brr++;
                        break;
                    }
                }
            }
            if(brr>red && A==1) {cout<<-1<<endl;
            return 0;}
        }
        else
        {
            for(int j=1; j<=n; j++)
            {
                for(int i=1; i<=n; i++)
                {
                    //cout<<j<<" "<<i<<" "<<br<<endl;
                    if(find_set1(j)!=find_set1(i))
                    {
                        connect_set1(j,i);
                        ans.push_back(make_pair(j,i));
                        brr++;
                        break;
                    }
                }
            }
            if(brr>blue) {cout<<-1<<endl;
            return 0;}
        }

        cout<<ans.size()<<endl;
        for(int i=0; i<ans.size(); i++)
            cout<<ans[i].first<<" "<<ans[i].second<<endl;

    }
}
/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
0 1

3
0 1 1
1 0 0
1 0 0
1 1

3
0 1 1
1 0 0
1 0 0
0 1

5
0 1 0 0 0
1 0 0 0 0
0 0 0 1 1
0 0 1 0 1
0 0 1 1 0
1 1

5
1 0 1 0 1
0 1 1 1 1
1 1 1 1 1
0 1 1 1 1
1 1 1 1 1
1 1

9
0 0 1 1 1 1 0 0 1
0 0 0 0 0 0 0 1 0
0 1 1 1 0 0 1 1 1
1 0 1 0 1 1 1 1 1
0 0 0 0 0 0 1 0 0
1 0 1 0 1 0 0 0 0
0 1 0 0 0 0 0 1 1
1 0 0 0 0 1 1 1 0
1 0 0 0 0 1 0 0 0
1 1
*/
