/**
* user:  A1009
* fname: Adriyan
* lname: Ibovski
* task:  colorgraph
* score: 20.0
* date:  2017-11-25 11:42:28.769253
*/
# include<iostream>
# include<algorithm>
# include<vector>
# include<utility>
# include<fstream>
using namespace std;

ifstream fin("123.out");

int a[256][256];
int parent[256],parent1[256];
int sz[1024],sz1[256];
void create(int x)
{
    parent[x]=x;
    sz[x]=1;
}

int find_set(int x)
{
    //cout<<x<<endl;
    if(parent[x]==x) return x;
    return parent[x]=find_set(parent[x]);
}

void connect_set(int x, int y)
{
    x=find_set(x); y=find_set(y);
    if(x!=y)
    {
        if(sz[x]<sz[y]) swap(x,y);;
        parent[y]=x;
        sz[x]+=sz[y];
    }

}
void create1(int x)
{
    parent1[x]=x;
    sz1[x]=1;
}

int find_set1(int x)
{
    //cout<<x<<endl;
    if(parent1[x]==x) return x;
    return parent1[x]=find_set1(parent1[x]);
}

void connect_set1(int x, int y)
{
    x=find_set1(x); y=find_set1(y);
    if(x!=y)
    {
        if(sz1[x]<sz1[y]) swap(x,y);;
        parent1[y]=x;
        sz1[x]+=sz1[y];
    }

}
int red,blue;
int r[256][256],b[256][256];
vector<pair<int,int> > ans;
vector<int> gr[256],gb[256];
bool visr[256],visb[256];
int brR,brB;
void dfsr(int u)
{
    brR++;
    visr[u]=1;
    for(int i=0; i<gr[u].size(); i++)
    {
        if(!visr[gr[u][i]] && r[u][gr[u][i]])
            dfsr(gr[u][i]);
    }
}
void dfsb(int u)
{
    brB++;
    visb[u]=1;
    for(int i=0; i<gb[u].size(); i++)
    {
        if(!visb[gb[u][i]] && b[u][gb[u][i]])
            dfsb(gb[u][i]);
    }
}
int firstb=1,firstr=1;
int main()
{
    int n;
    cin>>n;
    for(int i=0; i<=n; i++) {create(i); create1(i);}
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=n; j++)
        {
            cin>>a[i][j];
            if(i!=j)
            {
                if(a[i][j]==1)
                {
                    gb[i].push_back(j);
                    gb[j].push_back(i);
                    b[i][j]=1;
                    b[j][i]=1;
                    if(find_set(i)!=find_set(j))
                    {
                        firstb=i;
                        connect_set(i,j);

                    }
                    else blue++;
                }
                else
                {
                    r[i][j]=1;
                    r[j][i]=1;
                    gr[i].push_back(j);
                    gr[j].push_back(i);
                    if(find_set1(i)!=find_set1(j))
                    {
                        firstr=i;
                        connect_set1(i,j);
                    }
                    else red++;
                }
            }
        }
    }
    red/=2;
    blue/=2;
    int A,B;
    cin>>A>>B;
    bool fb=true,fr=true;
    for(int i=1; i<=n; i++)
    {
        if(find_set(firstb)!=find_set(i)) fb=false;
        if(find_set1(firstr)!=find_set1(i)) fr=false;
    }
    //cout<<fr<<" "<<fb<<endl;
    int brr=0,minbr=n,c=0;
    if(B==1)
    {

        if(!fb)
        {
            for(int j=1; j<=n; j++)
            {
                for(int i=1; i<=n; i++)
                {
                  //  cout<<i<<" "<<j<<" "<<br<<endl;
                    if(find_set(j)!=find_set(i))
                    {
                        connect_set(j,i);
                        b[i][j]=1;
                        b[j][i]=1;
                        r[i][j]=0;
                        r[j][i]=0;
                        ans.push_back(make_pair(j,i));
                        brr++;
                        break;
                    }
                }
            }
            if(brr>red && A==1) {cout<<-1<<endl;
            return 0;}
        }
        else
        {
            if(A==1)
            {
                for(int j=1; j<=n; j++)
                {
                    for(int i=1; i<=n; i++)
                    {
                        //cout<<j<<" "<<i<<" "<<br<<endl;
                        if(find_set1(j)!=find_set1(i))
                        {
                            connect_set1(j,i);
                            ans.push_back(make_pair(j,i));
                            brr++;
                            break;
                        }
                    }
                }
                if(brr>blue) {cout<<-1<<endl;
                return 0;}
            }
        }
        if(A==0)
        {
            dfsr(firstr);
            if(brR==n)
            {
                int brmax=0,c=0;
                for(int i=1; i<=n; i++)
                {
                    int br=0;
                    for(int j=1; j<=n; j++)
                    {
                        if(i!=j)
                        if(b[i][j]==1) br++;
                    }
                    if(br>brmax) {brmax=br; c=i;}
                }
                for(int i=1; i<=n; i++)
                {
                    if(i!=c)
                        if(b[c][i]==0)
                        {
                            b[c][i]=1;
                            b[i][c]=1;
                            r[i][c]=0;
                            r[c][i]=0;
                            ans.push_back(make_pair(c,i));
                            for(int j=0; j<=8; j++) visr[j]=0;
                            brR=0;
                            dfsr(firstr);
                            if(brR<n) break;
                        }
                }
            }
        }
        cout<<ans.size()<<endl;
        for(int i=0; i<ans.size(); i++)
            cout<<ans[i].first<<" "<<ans[i].second<<endl;

    }
    else
    {
        if(!fr)
        {
            for(int j=1; j<=n; j++)
                {
                    for(int i=1; i<=n; i++)
                    {
                        //cout<<j<<" "<<i<<" "<<br<<endl;
                        if(find_set1(j)!=find_set1(i))
                        {
                            connect_set1(j,i);
                            r[i][j]=1;
                            r[j][i]=1;
                            b[i][j]=0;
                            b[j][i]=0;
                            ans.push_back(make_pair(j,i));
                            brr++;
                            break;
                        }
                    }
                }
                if(brr>blue) {cout<<-1<<endl;
                return 0;}
        }
        dfsb(firstb);
        if(brB==n)
        {
            int brmax=0,c=0;
            for(int i=1; i<=n; i++)
            {
                int br=0;
                for(int j=1; j<=n; j++)
                {
                    if(i!=j)
                    if(r[i][j]==1) br++;
                }
                if(br>brmax) {brmax=br; c=i;}
            }
            for(int i=1; i<=n; i++)
            {
                if(i!=c)
                    if(r[c][i]==0)
                    {
                        r[c][i]=1;
                        r[i][c]=1;
                        b[i][c]=0;
                        b[c][i]=0;
                        ans.push_back(make_pair(c,i));
                        for(int j=0; j<=8; j++) visb[j]=0;
                        brB=0;
                        dfsb(firstr);
                        if(brB<n) break;
                    }
            }
        }
        cout<<ans.size()<<endl;
        for(int i=0; i<ans.size(); i++)
            cout<<ans[i].first<<" "<<ans[i].second<<endl;
    }
}
/*
4
1 0 0 1
0 0 1 0
0 1 1 0
1 0 0 0
0 1
17
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 1 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0
0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0
0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
0 0 1 0 0 0 0 0 0 0 0 1 1 0 1 0 0
0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 1 0 0 0 0 1 0 0
0 0 0 0 0 0 0 0 1 0 0 0 0 0 1 0 0
0 0 0 0 0 0 1 0 1 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 1 0 0 1 0 1 1 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
1 1


5
1 0 1 0 1
0 1 1 1 1
1 1 1 1 1
0 1 1 1 1
1 1 1 1 1
1 1

9
0 0 1 1 1 1 0 0 1
0 0 0 0 0 0 0 1 0
0 1 1 1 0 0 1 1 1
1 0 1 0 1 1 1 1 1
0 0 0 0 0 0 1 0 0
1 0 1 0 1 0 0 0 0
0 1 0 0 0 0 0 1 1
1 0 0 0 0 1 1 1 0
1 0 0 0 0 1 0 0 0
1 1
*/
