/**
* user:  A1010
* fname: Plamen
* lname: Dinev
* task:  clubs
* score: 30.0
* date:  2017-11-25 11:26:30.781859
*/
#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>
#include <utility>
#include <queue>
#include <set>
using namespace std;

uint32_t n;
uint16_t res;

uint16_t log2u32(uint32_t a)
{
    return (sizeof(uint32_t)<<3)-1-__builtin_clz(a);
}

void solve1()
{
    if(n==1)
    {
        cout<<0<<endl;
    }
    if(n==2)
    {
        cout<<1<<endl;
        cout<<"1 2"<<endl;
    }
    if(n==3)
    {
        cout<<1<<endl;
        cout<<"1 2"<<endl;
        cout<<"1 3"<<endl;
    }
    if(n==4)
    {
        cout<<2<<endl;
        cout<<"2 2 4"<<endl;
        cout<<"2 3 4"<<endl;
    }
    if(n==5)
    {
        cout<<2<<endl;
        cout<<"2 2 5"<<endl;
        cout<<"2 3 5"<<endl;
        cout<<"1 4"<<endl;
    }
    if(n==6)
    {
        cout<<3<<endl;
        cout<<"3 2 5 6"<<endl;
        cout<<"2 3 5"<<endl;
        cout<<"2 4 6"<<endl;
    }
    if(n==7)
    {
        cout<<3<<endl;
        cout<<"3 2 5 6"<<endl;
        cout<<"3 3 5 7"<<endl;
        cout<<"3 4 6 7"<<endl;
    }
    if(n==8)
    {
        cout<<4<<endl;
        cout<<"4 2 5 6 8"<<endl;
        cout<<"4 3 5 7 8"<<endl;
        cout<<"4 4 6 7 8"<<endl;
    }
    if(n==9)
    {
        cout<<3<<endl;
        cout<<"3 2 6 8"<<endl;
        cout<<"3 3 6 9"<<endl;
        cout<<"3 4 7 8"<<endl;
        cout<<"3 5 7 9"<<endl;
    }
    if(n==10)
    {
        cout<<4<<endl;
        cout<<"4 2 6 8 10"<<endl;
        cout<<"3 3 6 9"<<endl;
        cout<<"3 4 7 8"<<endl;
        cout<<"4 5 7 9 10"<<endl;
    }
    if(n==11)
    {
        cout<<4<<endl;
        cout<<"4 2 6 8 10"<<endl;
        cout<<"4 3 6 9 11"<<endl;
        cout<<"4 4 7 8 11"<<endl;
        cout<<"4 5 7 9 10"<<endl;
    }
    if(n==12)
    {
        cout<<5<<endl;
        cout<<"5 2 6 8 10 12"<<endl;
        cout<<"5 3 6 9 11 12"<<endl;
        cout<<"5 4 7 8 11 12"<<endl;
        cout<<"4 5 7 9 10"<<endl;
    }
    if(n==13)
    {
        cout<<6<<endl;
        cout<<"5 2 6 8 10 12"<<endl;
        cout<<"6 3 6 9 11 12 13"<<endl;
        cout<<"6 4 7 8 11 12 13"<<endl;
        cout<<"5 5 7 9 10 13"<<endl;
    }
    if(n==14)
    {
        cout<<7<<endl;
        cout<<"6 2 6 8 10 12 14"<<endl;
        cout<<"7 3 6 9 11 12 13 14"<<endl;
        cout<<"6 4 7 8 11 12 13"<<endl;
        cout<<"6 5 7 9 10 13 14"<<endl;
    }
    if(n==15)
    {
        cout<<7<<endl;
        cout<<"7 2 6 8 10 12 14 15"<<endl;
        cout<<"7 3 6 9 11 12 13 14"<<endl;
        cout<<"7 4 7 8 11 12 13 15"<<endl;
        cout<<"7 5 7 9 10 13 14 15"<<endl;
    }
}

vector < vector <uint8_t> > comb;
vector < uint8_t > tmp_c;

void rec(uint8_t cur)
{
    tmp_c.push_back(cur);
    comb.push_back(tmp_c);

    for(uint32_t i=cur+1; i<res; i++)
        rec(i);

    tmp_c.pop_back();
}


void solve2()
{
    vector < vector <uint64_t> > clubs;
    clubs.resize(res);
    for(uint64_t i=0; i<comb.size(); i++)
        clubs.reserve((n>>1)+20);
    comb.reserve(res*((n>>1)+1));
    tmp_c.reserve(res);
    for(uint8_t i=0; i<res; i++)
        rec(i);
    /*for(uint32_t i=0; i<comb.size(); i++)
    {
        cout<<i<<": ";
        for(uint32_t j=0; j<comb[i].size(); j++)
            cout<<(short)comb[i][j]<<' ';
        cout<<endl;
    }*/
    uint64_t cur=2;
    for(uint64_t i=0; i<comb.size(); i++)
    {
        for(uint64_t j=0; j<comb[i].size(); j++)
            clubs[comb[i][j]].push_back(cur);
        cur++;
        if(cur>n)break;
    }
    size_t max_size=0;
    for(uint64_t i=0; i<clubs.size(); i++)
        max_size=max<size_t>(max_size, clubs[i].size());
    cout<<max_size<<'\n';
    for(uint64_t i=0; i<clubs.size(); i++)
    {
        cout<<clubs[i].size()<<" ";
        for(uint64_t j=0; j<clubs[i].size(); j++)
            cout<<clubs[i][j]<<' ';
        cout<<'\n';
    }
}

int main()
{
    cin>>n;
    res=log2u32(n);
    if((1<<res)!=n)res++;
    cout<<res<<' ';
    if(n<=15)
    {
        solve1();
        return 0;
    }
    else
    {
        solve2();
        return 0;
    }

    return 0;
}

