/**
* user:  A1013
* fname: Viktor
* lname: Venkov
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 10:58:11.903108
*/
#include<iostream>
#include<vector>
#include<stack>
using namespace std;
int n, bl[256],re[256];
    vector<int> r[256];
    vector<int> b[256];
    int posb[256];
    int posr[256];
    stack<pair<int, int> > ans;
void bdfs(int u)
{
    posb[u]=1;
    int s=b[u].size();
    for(int v=0;v<s;v++)
    {
        if(posb[b[u][v]]==0){bdfs(b[u][v]);}
    }
}
void rdfs(int u)
{
    posr[u]=1;
    int s=r[u].size();
    for(int v=0;v<s;v++)
    {
        if(posr[r[u][v]]==0){rdfs(r[u][v]);}
    }
}
void reddfs(int u)
{
    posr[u]=1;
    int s=r[u].size();
    int fl=0;
    for(int v=0;v<s;v++)
    {

        if(posr[r[u][v]]==0){reddfs(r[u][v]);fl=1;}
    }
    if(fl==0)
    {
        for(int i=1;i<=n;i++)
            if(u!=i and posr[i]==0 and b[i].size()>1){ans.push(make_pair(u,i));reddfs(i);fl=1;}
    }
    if(fl==0)
    {
        for(int i=1;i<=n;i++)
            if(u!=i and posr[i]==0){ans.push(make_pair(u,i));reddfs(i);}
    }
}
void blackdfs(int u)
{
    posb[u]=1;
    int s=b[u].size();
    int fl=0;
    for(int v=0;v<s;v++)
    {

        if(posb[b[u][v]]==0){blackdfs(b[u][v]);fl=1;}
    }
    if(fl==0)
    {
        for(int i=1;i<=n;i++)
            {
            if(u!=i and posb[i]==0 and r[i].size()>1){ans.push(make_pair(u,i));blackdfs(i);fl=1;}
            }
    }
    if(fl==0)
    {
        for(int i=1;i<=n;i++)
            if(u!=i and posb[i]==0){ans.push(make_pair(u,i));blackdfs(i);}
    }
}
//////////////////////////////////////////////////
void svyrjired(int u)
{

    posr[u]=1;
    int s=r[u].size();
    int fl=0;
    for(int v=0;v<s;v++)
    {

        if(posr[r[u][v]]==0){svyrjired(r[u][v]);fl=1;}
    }
    if(fl==0)
    {
        int mini=100000000, minv=0;
        for(int i=1;i<=n;i++)
            if(u!=i and posr[i]==0 and b[i].size()<mini){mini=b[i].size();minv=i;}

        r[u].push_back(minv);r[minv].push_back(u);
     s=b[minv].size();
    int fl1=0;
    for(int v=0;v<s;v++)
    {

                if(b[minv][v]==u){fl1=1;}
            if(fl1==1)b[minv][v]=b[minv][v+1];

    }
     s=b[u].size();
    int fl2=0;
    for(int v=0;v<s-1;v++)
    {
            if(b[u][v]==minv){fl2=1;}
            if(fl2==1)b[minv][v]=b[minv][v+1];
    }
   // cout<<b[u].size()<<endl;
    b[u].pop_back();
    b[minv].pop_back();
    //cout<<b[u].size()<<endl;
        ans.push(make_pair(u,minv));//if(posr[minv]==0)svyrjired(minv);
    }
}
void svyrjiblack(int u)
{

    posb[u]=1;
    int s=b[u].size();
    int fl=0;
    for(int v=0;v<s;v++)
    {

        if(posb[b[u][v]]==0){svyrjiblack(b[u][v]);fl=1;}
    }
    if(fl==0)
    {
        int mini=100000000, minv=0;
        for(int i=1;i<=n;i++)
            if(u!=i and posb[i]==0 and r[i].size()<mini){mini=r[i].size();minv=i;}

        b[u].push_back(minv);b[minv].push_back(u);
     s=r[minv].size();
    int fl1=0;
    for(int v=0;v<s;v++)
    {

                if(r[minv][v]==u){fl1=1;}
            if(fl1==1)r[minv][v]=r[minv][v+1];

    }
     s=r[u].size();
    int fl2=0;
    for(int v=0;v<s;v++)
    {
            if(r[u][v]==minv){fl2=1;}
            if(fl2==1)r[minv][v]=r[minv][v+1];
    }
    r[u].pop_back();
    r[minv].pop_back();
        ans.push(make_pair(u,minv));//svyrjiblack(minv);
    }
}

//////////////////////////////////////////////////
int main()
{

    cin>>n;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            int x;
            cin>>x;
            if(j-i>=1)
            {
                if(x==0)
                {
                    r[i].push_back(j);
                    r[j].push_back(i);
                    re[i]++;
                    re[j]++;
                }
                else
                {
                    b[i].push_back(j);
                    b[j].push_back(i);
                    bl[i]++;
                    bl[j]++;
                }
            }
        }
    }
    int A,B;
    cin>>A>>B;
    if((A==0 and B==0) or (A==0 and B==0 and n<=3)){cout<<-1<<endl;return 0;}
    int blackcount=0,redcount=0;
    if(A==1 and B==1)
    {

        for(int i=1;i<=n;i++)
        {
            if(posb[i]==0){
            bdfs(i);
            blackcount++;
            }
        }

        for(int i=1;i<=n;i++)
        {
            if(posr[i]==0){
            rdfs(i);
            redcount++;
            }
        }
        if(blackcount==1 and redcount==1)
        {
            cout<<0<<endl;
            return 0;
        }
        for(int i=0;i<256;i++)
        {
            posb[i]=0;
            posr[i]=0;
        }
        if(blackcount==1)
        {

            reddfs(1);
        }
        if(redcount==1)
        {
            blackdfs(1);
        }

    }
    if(A==1 and B==0)
    {
        for(int i=0;i<256;i++)
        {
            posb[i]=0;
            posr[i]=0;
        }
        for(int i=1;i<=n;i++)
        {
            if(posb[i]==0){
            bdfs(i);
            blackcount++;
            }
        }

        for(int i=1;i<=n;i++)
        {
            if(posr[i]==0){
            rdfs(i);
            redcount++;
            }
        }
        if(blackcount!=1 and redcount==1)
        {
            cout<<0<<endl;
            return 0;
        }
        for(int i=0;i<256;i++)
        {
            posb[i]=0;
            posr[i]=0;
        }
        for(int i=1;i<=n;i++)
        if(posr[i]==0)
        svyrjired(i);
    }
    if(A==0 and B==1)
    {
        for(int i=0;i<256;i++)
        {
            posb[i]=0;
            posr[i]=0;
        }
        for(int i=1;i<=n;i++)
        {
            if(posb[i]==0){
            bdfs(i);
            blackcount++;
            }
        }

        for(int i=1;i<=n;i++)
        {
            if(posr[i]==0){
            rdfs(i);
            redcount++;
            }
        }
        if(blackcount==1 and redcount!=1)
        {
            cout<<0<<endl;
            return 0;
        }
        for(int i=0;i<256;i++)
        {
            posb[i]=0;
            posr[i]=0;
        }
        svyrjiblack(1);
    }
    cout<<ans.size()<<endl;
        while(!ans.empty())
        {
            cout<<ans.top().first<<" "<<ans.top().second<<endl;
            ans.pop();
        }
    return 0;
}
