/**
* user:  A1016
* fname: Yoana
* lname: Zelova
* task:  crypto
* score: 0.0
* date:  2017-11-25 12:04:33.428467
*/
#include<bits/stdc++.h>
using namespace std;

vector<int> primes;

void primeNumbers()
{
    bool pr[1024];
    for(int i=1; i<=1024; i++)
        pr[i]=false;
    for(int i=2; i<=400; i++)
    {
        for(int j=2; j*i<=500; j++)
            pr[i*j]=true;
    }
    for(int i=2; i<=500; i++)
        if(!pr[i])
        {
            //cout<<i<<endl;
            primes.push_back(i);
        }
}

const long long MOD=1e9+7;

int main()
{
    primeNumbers();
    int n,p,k;
    long long ans=0;
    cin>>n>>k>>p;
    int a[512];
    int dif[250010];
    for(int i=1; i<=n; i++)
        a[i]=primes[i-1];
    for(int i=k; i<=n; i++)
    {
        for(int j=1; j<=n-i+1; j++)
        {
            int firstMin=INT_MAX, secondMin=INT_MAX;
            for(int l=j; l<=j+i-1; l++)
            {
                firstMin=min(firstMin,a[l]);
            }
            for(int l=j; l<=j+i-1; l++)
            {
                if(firstMin!=a[l])secondMin=min(secondMin, a[l]);
            }
            //cout<<firstMin<<" "<<secondMin<<endl;
            if(firstMin!=INT_MAX && secondMin!=INT_MAX)dif[firstMin*secondMin]=1;
        }
    }
    int cnt=0;
    for(int i=1; i<=250000; i++)
        cnt+=dif[i];
    if(cnt==p)ans++;
    while(next_permutation(a+1, a+n+1))
    {
        for(int i=1; i<=250000; i++)
            dif[i]=0;

        for(int i=k; i<=n; i++)
        {
            for(int j=1; j<=n-i+1; j++)
            {
                int firstMin=INT_MAX, secondMin=INT_MAX;
                for(int l=j; l<=j+i-1; l++)
                {
                    firstMin=min(firstMin,a[l]);
                }
                for(int l=j; l<=j+i-1; l++)
                {
                    if(firstMin!=a[l])secondMin=min(secondMin, a[l]);
                }
                //cout<<firstMin<<" "<<secondMin<<endl;
                if(firstMin!=INT_MAX && secondMin!=INT_MAX)dif[firstMin*secondMin]=1;
            }
        }
        int cnt=0;
        for(int i=1; i<=250000; i++)
            cnt+=dif[i];
        if(cnt==p)ans=(ans%MOD+1)%MOD;
    }
    cout<<ans<<endl;
    return 0;
}
