/**
* user:  A1020
* fname: Emil
* lname: Indzhev
* task:  crypto
* score: 10.0
* date:  2017-11-25 11:31:31.556106
*/
#include<iostream>
#include<algorithm>
#include<math.h>
#include<stdlib.h>
#include<vector>
using namespace std;
int n,k,p;
int ans;
const int MAX_N=400;
const int MOD=(1e9)+7;
int a[MAX_N];
bool found[1<<12];
bool done=0;
void input()
{
    cin>>n>>k>>p;
}
void output()
{
    cout<<ans<<endl;
}
void check(int a[])
{
    int fp=0;
    int b[10];
    int c;
    int mask;
    for (int i=0;i<1<<12;++i)
    {
        found[i]=0;
    }
    for (int i=0;i<n;++i)
    {
        c=1;
        b[0]=a[i];
        for (int j=i+1;j<n;j++)
        {
            b[c++]=a[j];
            if (c>=k)
            {
                mask=0;
                sort(b,b+c);
                for (int q=0;q<k;++q)
                {
                    mask+=1<<(b[q]-1);
                }
                if (found[mask]==0)
                {
                    ++fp;
                    found[mask]=1;
                }
            }
        }
    }
    if (fp==p)
    {
        ++ans;
        if (ans>=MOD) ans-=MOD;
    }
}
void permute()
{
    if (!next_permutation(a,a+n)) done=1;
}
void step()
{
    check(a);
    permute();
}
void init()
{
    for (int i=0;i<n;++i)
    {
        a[i]=i+1;
    }
}
void solve()
{
    ans=0;
    init();
    while (done==0)
    {
        step();
    }
}
int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();
    output();

    return 0;
}
