/**
* user:  A1020
* fname: Emil
* lname: Indzhev
* task:  colorgraph
* score: 10.0
* date:  2017-11-25 12:16:00.667807
*/
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

const int MAX_N=256;
int n;
int con[MAX_N][MAX_N];
int a,b;


void input()
{
    cin>>n;
    for (int i=0;i<n;++i)
    {
        for (int j=0;j<n;++j)
        {
            cin>>con[i][j];
        }
    }
    cin>>a>>b;
}
int max_con=-1;
int find_most_connected(int col)
{
    int total;
    int ans=0;
    for (int i=0;i<n;++i)
    {
        total=0;
        for (int j=0;j<n;++j)
        {
            if (i==j) continue;
            total+=(con[i][j]==col);
        }
        if (total>max_con)
        {
            max_con=total;
            ans=i;
        }
    }
    return ans;
}
void color_all_edges(int v, int col)
{
    for (int j=0;j<n;++j)
    {
        if (v==j) continue;
        if (con[v][j]!=col)
        {
            cout<<v+1<<' '<<j+1<<'\n';
        }
    }
}
void solve()
{
    if (a==0 && b==0)
    {
        cout<<-1<<'\n';
        return;
    }
    if (a==1 && b==1)
    {
        if (n<=4) cout<<-1<<'\n';
        else cout<<0<<'\n';//subtask12();
        return;
    }
    int mc;
    if (a==1)
    {
        mc=find_most_connected(0);
        cout<<n-1-max_con<<'\n';
        color_all_edges(mc,0);
    }
    else if (b==1)
    {
        mc=find_most_connected(1);
        cout<<n-1-max_con<<'\n';
        color_all_edges(mc,1);
    }
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();

    return 0;
}
