/**
* user:  A1024
* fname: Yordan
* lname: Dimitrov
* task:  colorgraph
* score: 5.0
* date:  2017-11-25 12:28:50.103685
*/
#include<bits/stdc++.h>
#define MAX_N 256
#define INF MAX_N*MAX_N
using namespace std;
int n, a[MAX_N][MAX_N], currans[MAX_N][MAX_N];
bool used[MAX_N];
int currmin=INF, x, y, cnt;
void read()
{
    scanf("%d", &n);

    for(int i=1; i<=n; i++)
        for(int j=1; j<=n; j++)
            scanf("%d", &a[i][j]);
    scanf("%d %d", &x, &y);
}
void DFS(int u, bool state)
{
    used[u]=1;
    cnt++;
    for(int i=1; i<=n; i++)
        if(a[u][i]==state)
            if(used[i]==0)
                DFS(i, state);
}
bool check()
{
    memset(used, 0, sizeof(used));
    cnt=0;
    DFS(1, 0);
    bool ans1=cnt/n;

    memset(used, 0, sizeof(used));
    cnt=0;
    DFS(1, 1);
    bool ans2=cnt/n;

    if(x!=ans1||y!=ans2)
        return false;
    return true;
}
void changecurrmin()
{
    for(int i=1; i<=n; i++)
        for(int j=i+1; j<=n; j++)
            currans[i][j]=a[i][j];
}
void solve(int x, int y, bool flip, int flips)
{
    //cerr<<x<<' '<<y<<endl;
    if(flip)
        a[x][y]=a[y][x]=1-a[x][y];
    if(x>=n&&y>=n+1)
    {
        if(check()&&flips<currmin)
        {
            currmin=flips;
            changecurrmin();
        }
        if(flip)
            a[x][y]=a[y][x]=1-a[x][y];
        return;
    }
    if(y<n)
    {
        solve(x, y+1, 1, flips+1);
        solve(x, y+1, 0, flips);
    }
    else
    {
        solve(x+1, x+2, 1, flips+1);
        solve(x+1, x+2, 0, flips);
    }
    if(flip)
        a[x][y]=a[y][x]=1-a[x][y];
}
void print()
{
    vector<pair<int, int>> ans;
    for(int i=1; i<=n; i++)
        for(int j=i+1; j<=n; j++)
            if(a[i][j]!=currans[i][j])
                ans.push_back(make_pair(i, j));
    if(currmin==INF)
    {
        printf("-1\n");
        return;
    }
    printf("%d\n", currmin);
    for(int i=0; i<currmin; i++)
        printf("%d %d\n", ans[i].first, ans[i].second);
}
int main()
{
    //freopen("input.txt", "r", stdin);
    read();
    solve(1, 2, 1, 1);
    solve(1, 2, 0, 0);
    print();
    return 0;
}
