/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  clubs
* score: 5.0
* date:  2017-11-25 08:07:14.102444
*/
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAX_N = 1e5 + 5;

int CalcCntOnes(int n);
int LeftmostOneInd(int n);

vector< int > clubs[MAX_N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int n;
	cin >> n;
	
	int removedNumber = 0, maxCntOnes = 0, maxOneInd;
	for(int i = 1; i <= n; i++) {
		if(LeftmostOneInd(i) > maxOneInd) {
			maxCntOnes = CalcCntOnes(i);
			maxOneInd = LeftmostOneInd(i);
			removedNumber = i;
		}
		else if(LeftmostOneInd(i) == maxOneInd && CalcCntOnes(i) > maxCntOnes) {
			maxCntOnes = CalcCntOnes(i);
			removedNumber = i;
		}
	}

	int maxCntBits = 0, maxCntInClub = 0;
	for(int i = 1; i <= n; i++) {
		if(i == removedNumber) {
			continue;
		}

		int currBit = 0;

		while((1 << currBit) <= i) {
			if(currBit + 1 > maxCntBits) {
				maxCntBits = currBit + 1;
			}

			if((i & (1 << currBit)) != 0) {
				clubs[currBit].push_back(i);
				if(clubs[currBit].size() > maxCntInClub) {
					maxCntInClub = clubs[currBit].size();
				}
			}
			
			currBit++;
		}
	}

	cout << maxCntBits << " " << maxCntInClub << endl;
	for(int i = 0; i < maxCntBits; i++) {
		cout << clubs[i].size() << " ";
		for(int x : clubs[i]) {
			cout << x << " ";
		}
		cout << endl;
	}

	return 0;
}

int CalcCntOnes(int n) {
	int currBit = 0, ans = 0;
	while((1 << currBit) <= n) {
		if((n & (1 << currBit)) != 0) {
			ans++;
		}
		currBit++;
	}
	
	return ans;
}

int LeftmostOneInd(int n) {
	int ans = 0;
	while(n > 0) {
		n >>= 1;
		ans++;
	}

	return ans;
}
