/**
* user:  A1026
* fname: Ivo
* lname: Karagyozov
* task:  crypto
* score: 0.0
* date:  2017-11-25 11:42:14.198288
*/
#include <bits/stdc++.h>
#define endl '\n'
#define NextPermutation next_permutation
using namespace std;

const int PRIMES[] = { 2, 3, 5, 7, 11, 13, 17, 19, 23, 29 };

int n, k, p;

bool IsOk(vector< int > perm);

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n >> k >> p;	

	vector< int > perm;

	for(int i = 0; i < n; i++) {
		perm.push_back(PRIMES[i]);
	}

	int ans = 0;
	do {
		if(IsOk(perm)) {
			ans++;
		}
	}
	while(NextPermutation(perm.begin(), perm.end()));

	cout << ans << endl;
	return 0;
}

bool IsOk(vector< int > perm) {
	int totalCnt = 0;
	set< int > currNumbers;
	map< ll, bool > isAlreadySeen;
	
	for(int i = k; i <= n; i++) {
		ll product = 1;

		for(int j = 0; j < i; j++) {
			currNumbers.insert(perm[j]);
		}

		int cnt = 0;
		for(int x : currNumbers) {
			product *= 1ll * x;
			cnt++;

			if(cnt == k) {
				break;
			}
		}

		if(isAlreadySeen.count(product) == 0) {
			isAlreadySeen[product] = true;
			totalCnt++;
		}

		for(int j = i; j < n; j++) {
			product = 1;
			currNumbers.insert(perm[j]);
			currNumbers.erase(perm[j - i]);

			int cnt = 0;
			for(int x : currNumbers) {
				product *= 1ll * x;
				cnt++;

				if(cnt == k) {
					break;
				}
			}

			if(isAlreadySeen.count(product) == 0) {
				isAlreadySeen[product] = true;
				totalCnt++;
			}
		}
	}

	return (totalCnt == p);
}
