/**
* user:  A1033
* fname: Antani
* lname: Gospodinov
* task:  clubs
* score: 35.0
* date:  2017-11-25 12:33:01.794107
*/
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#define mp make_pair
#define pb push_back
using namespace std;
const int N=2e5+15;
const int B=23;

int n;

vector <int> c[B];
int c_cnt=-1,c_minmax;

int a[N];
int rm[N];
int bits[B],high_bit;

int best_bits[B];
int best_a[N];

int temp_a[N];
int temp_bits[N];

void transfer()
{
    int i;
    for(i=0;i<=n;i++)
    {
        best_a[i]=temp_a[i];
    }
    for(i=0;i<B;i++)
    {
        best_bits[i]=temp_bits[i];
    }
}

bool vis[N];

bool check(int k)
{
   memset(vis,false,sizeof(vis));

   int i,j;
   for(i=0;i<n;i++)
   {
       temp_a[i]=a[i];
       temp_bits[i]=bits[i];
       vis[a[i]]=true;
   }

   int x;
   for(i=0;i<n;i++)
   {
       for(j=0;j<B;j++)
       {
          if(temp_bits[j] <= k)
            continue;

          if(!(temp_a[i] & (1 << high_bit)))
          {
              if(temp_a[i] & (1 << j))
              {
                x=temp_a[i];
                x^=(1 << j);
                x^=(1 << high_bit);
                if(!vis[x])
                {
                    temp_bits[j]--;
                    temp_bits[high_bit]++;

                    temp_a[i]^=(1 << j);
                    temp_a[i]^=(1 << high_bit);

                    vis[temp_a[i]]=true;
                }
              }
          }
       }
   }

   for(i=0;i<B;i++)
   {
       if(temp_bits[i] > k)
        return false;
   }

   return true;
}

bool popcount_sort(int x,int y)
{
    if(__builtin_popcount(x) != __builtin_popcount(y))
     return __builtin_popcount(x) < __builtin_popcount(y);

    return x<y;
}

void calc_a()
{
    int i,j;
    for(i=0;i<n;i++)
    {
      a[i]=i;
      for(j=0;j<B;j++)
      {
          if(a[i] & (1 << j))
          {
              high_bit=max(high_bit,j);
              bits[j]++;
          }
      }
    }

    sort(a,a+n,popcount_sort);

    /// BINARY SEARCH ON ANSWER! (BITS[i] CANT BE MORE THAN MID)
    int low,high,mid;
    low=1;
    high=n;
    while(low<=high)
    {
        mid=(low+high)/2;

        if(check(mid))
        {
            transfer();
            high=mid-1;
        }
        else
        {
            low=mid+1;
        }
    }

    for(i=0;i<n;i++)
    {
        a[i]=best_a[i];
    }
    for(i=0;i<B;i++)
    {
        bits[i]=best_bits[i];
    }

    int ind=1;
    for(i=0;i<n;i++)
    {
            rm[a[i]]=ind++;
    }

}

int main()
{
   int i,j;

   scanf("%d", &n);
   calc_a();
   for(i=0;i<n;i++)
   {
       for(j=0;j<B;j++)
       {
           if(a[i] & (1 << j))
           {
              c[j].pb(a[i]);
              c_cnt=max(c_cnt,j);
           }
       }
   }

   c_cnt++;
   for(i=0;i<c_cnt;i++)
   {
       c_minmax=max(c_minmax,(int)c[i].size());
   }

   printf("%d %d\n", c_cnt, c_minmax);
   for(i=0;i<c_cnt;i++)
   {
       printf("%d ",(int)c[i].size());
       for(j=0;j<c[i].size();j++)
       {
         printf("%d ", rm[c[i][j]]);
       }
       printf("\n");
   }

   return 0;
}
