/**
* user:  А1112
* fname: Георги Делянов Генков
* lname: Габрово
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 07:58:13.151010
*/
#include<iostream>
#include<vector>
using namespace std;

int arr[256][256];
int cntRed[256], cntBlue[256];
vector<pair<int,int> >changes;
int n;
int a, b;
int moves = 0;

void fixRed(int i){
    for(int j = 1; j <= n; j++){
        if(i != j){
            if(arr[i][j] == 1 && cntRed[j] != 0 && cntBlue[j] > 1){
                arr[i][j] = 0;
                arr[j][i] = 0;
                cntRed[i]++;
                cntRed[j]++;

                cntBlue[i]--;
                cntBlue[j]--;

                moves++;

                changes.push_back(pair<int,int>(i,j));
                //cout<<"Switched " << i <<" - " << j << "to red." << endl;

                return;
            }
        }
    }
}

void fixBlue(int i){
    for(int j = 1; j <= n; j++){
        if(i != j){
            if(arr[i][j] == 0 && cntBlue[j] != 0 && cntRed[j] > 1){
                arr[i][j] = 1;
                arr[j][i] = 1;

                cntRed[i]--;
                cntRed[j]--;

                cntBlue[i]++;
                cntBlue[j]++;

                moves++;

                //cout<<"Switched " << i <<" - " << j << "to blue." << endl;
                changes.push_back(pair<int,int>(i,j));
                return;
            }
        }
    }
}

void analyze(){
    for(int i = 1; i <= n; i++){
        if(cntRed[i] == 0){
            fixRed(i);
        }

        if(cntBlue[0] == 0){
            fixBlue(i);
        }
    }

}

int main(){
    cin>>n;


    int temp;

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= n; j++){
            cin>>arr[i][j];
            if(i!=j){
                if(arr[i][j] == 0){
                   cntRed[i]++;
                   //cntRed[j]++;
                }else{
                    //cntBlue[i]++;
                    cntBlue[j]++;
                }
            }else{
                arr[i][j] = -1;
            }
        }
    }

    cin>>a>>b;

    if(a == 1 && b == 1 && n%2 != 0){
        cout<<-1<<endl;
        return 0;
    }





    analyze();

    /*
    for(int i = 1; i <= n; i++){
        cout<<cntRed[i]<<" " << cntBlue[i] <<endl;
    }
    */


    cout<<moves<<endl;

    for(pair<int,int> p : changes){
        cout<<p.first << " " << p.second << endl;
    }
    return 0;
}

/*
4
1 0 0 0
0 0 1 0
0 1 1 0
0 0 0 0
1 1


*/
