/**
* user:  А1115
* fname: Валери Валериев Станчев
* lname: Русе
* task:  colorgraph
* score: 5.0
* date:  2017-11-25 09:56:53.368611
*/
#include <cstdio>
#include <cstring>
#include <queue>
#include <utility>
#include <vector>

using namespace std;

int n, mincnt=1<<31-1;
bool G[251][251], A, B, a1, b1; //0 - red, 1 - blue
bool used[251];
vector<pair<int, int> > v;
queue<int> q;
vector<pair<int, int> > st, ans;

bool BFS(int curr, bool what)
{
    memset(used, false, sizeof used);
    q.push(curr);
    used[curr]=true;
    int qtop, br=1;
    while(!q.empty())
    {
        qtop=q.front();
        q.pop();
        for(int i=1; i<=n; ++i)
        {
            if(i!=qtop && G[i][qtop]==what && !used[i])
            {
                br++;
                used[i]=true;
                q.push(i);
            }
        }
    }
    if(br==n) return true;
    return false;
}

void solve(int idx)
{
    if(st.size()>mincnt)
    {
        return;
    }
    for(int i=idx; i<(int)v.size(); ++i)
    {
        st.push_back(v[i]);
        G[v[i].first][v[i].second]=G[v[i].second][v[i].first]=(G[v[i].first][v[i].second]?0:1);
        a1=BFS(1, 0);
        b1=BFS(1, 1);
        if(a1==A && b1==B)
        {
            if(mincnt>st.size())
            {
                //printf("yes because mincnt=%d and cnt=%d\n", mincnt, st.size());
                mincnt=st.size();
                ans.clear();
                for(auto j:st)
                {
                    ans.push_back(j);
                }
            }
            st.pop_back();
            G[v[i].first][v[i].second]=G[v[i].second][v[i].first]=(G[v[i].first][v[i].second]?0:1);
            return;
        }
        solve(i+1);
        st.pop_back();
        G[v[i].first][v[i].second]=G[v[i].second][v[i].first]=(G[v[i].first][v[i].second]?0:1);
    }
}

int main ()
{
    //freopen("i33.txt", "r", stdin);
    scanf("%d", &n);
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            if(i<j) v.push_back({i, j});
            scanf("%d", &G[i][j]);
        }
    }
    scanf("%d %d", &A, &B); //A - red, B - blue
    a1=BFS(1, 0);
    b1=BFS(1, 1);
    if(a1==A && b1==B)
    {
        printf("0\n");
        return 0;
    }
    solve(0);
    if(mincnt==1<<31-1)
    {
        printf("-1\n");
    }
    else
    {
        printf("%d\n", mincnt);
        for(auto i:ans)
        {
            printf("%d %d\n", i.first, i.second);
        }
    }
    return 0;
}
