/**
* user:  А1115
* fname: Валери Валериев Станчев
* lname: Русе
* task:  colorgraph
* score: 5.0
* date:  2017-11-25 12:13:57.841292
*/
#include <cstdio>
#include <cstring>
#include <queue>
#include <utility>
#include <vector>

using namespace std;

int n, mincnt=1<<31-1;
int br=0;
bool G[251][251], A, B, a1, b1;
bool done[251][251]; //0 - red, 1 - blue
bool used[251];
vector<pair<int, int> > v;
queue<int> q;
vector<pair<int, int> > st, ans;

bool DFS(int curr, bool what)
{
    br++;
    used[curr]=true;
    if(br==n) return true;
    bool aa=false;
    for(int i=1; i<=n; ++i)
    {
        if(!used[i] && G[i][curr]==what)
        {
            aa=DFS(i, what);
        }
    }
    return aa;
}

void solve()
{
    if(st.size()>mincnt)
    {
        return;
    }
    for(int i=0; i<(int)v.size(); ++i)
    {
        if(done[v[i].first][v[i].second]) return;
        st.push_back(v[i]);
        done[v[i].first][v[i].second]=true;
        G[v[i].first][v[i].second]=G[v[i].second][v[i].first]=(G[v[i].first][v[i].second]?0:1);
        memset(used, false, sizeof used);
        br=0;
        a1=DFS(1, 0);
        memset(used, false, sizeof used);
        br=0;
        b1=DFS(1, 1);
        if(a1==A && b1==B)
        {
            if(mincnt>st.size())
            {
                //printf("yes because mincnt=%d and cnt=%d\n", mincnt, st.size());
                mincnt=st.size();
                ans.clear();
                for(auto j:st)
                {
                    ans.push_back(j);
                }
            }
            done[v[i].first][v[i].second]=false;
            st.pop_back();
            G[v[i].first][v[i].second]=G[v[i].second][v[i].first]=(G[v[i].first][v[i].second]?0:1);
            return;
        }
        solve();
        done[v[i].first][v[i].second]=false;
        st.pop_back();
        G[v[i].first][v[i].second]=G[v[i].second][v[i].first]=(G[v[i].first][v[i].second]?0:1);
    }
}

int main ()
{
    //freopen("i33.txt", "r", stdin);
    scanf("%d", &n);
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            if(i<j) v.push_back({i, j});
            scanf("%d", &G[i][j]);
        }
    }
    scanf("%d %d", &A, &B); //A - red, B - blue
    a1=DFS(1, 0);
    br=0;
    memset(used, false, sizeof used);
    b1=DFS(1, 1);
    if(a1==A && b1==B)
    {
        printf("0\n");
        return 0;
    }
    memset(done, false, sizeof done);
    solve();
    if(mincnt==1<<31-1)
    {
        printf("-1\n");
    }
    else
    {
        printf("%d\n", mincnt);
        for(auto i:ans)
        {
            printf("%d %d\n", i.first, i.second);
        }
    }
    return 0;
}
