/**
* user:  А1120
* fname: Камен Валентинов Павлов
* lname: София-град
* task:  colorgraph
* score: 0.0
* date:  2017-11-25 11:32:16.504598
*/
#include <iostream>
#include <vector>
#include <stack>
#include <utility>

using namespace std;

int n, mini = 99999;
vector <int> gr[251];
stack <pair <int, int> > izh, maybe;
bool a[2], g[251][251], used[251], usedp[251][251];

void anul() {
    for(int i = 0; i < n; i ++) {
        used[i] = false;
    }
}

void equate(stack <pair <int, int> > &q, stack <pair <int, int> > w) {
    while(!q.empty()) {
        q.pop();
    }
    while(!w.empty()) {
        q.push(w.top());
        w.pop();
    }
}

bool check(int x, bool y) {
    for(int i = 0; i < gr[x].size(); i ++) {
        if(!used[gr[x][i]] && g[x][gr[x][i]] == y) {
            used[gr[x][i]] = true;
            if(check(gr[x][i], y)) return true;
            used[gr[x][i]] = false;
        }
    }
    for(int i = 0; i < n; i ++) {
        if(!used[i]) return false;
    }
}

void cycle(stack <pair <int, int> > &z) {
    bool red, blue;
    anul();
    red = check(0, 0);
    anul();
    blue = check(0, 1);
    if(red == a[0] && blue == a[1]) {
        if(z.size() < mini) {
            mini = z.size();
            equate(izh, z);
        }
        return;
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((g[i][j] && !red || !g[i][j] && !blue) && !usedp[i][j]) {
                z.push({i, j});
                usedp[i][j] = true;
                cycle(z);
                z.pop();
                usedp[i][j] = false;
            }
        }
    }
}

int main() {
    cin >> n;
    for(int i = 0; i < n; i ++) {
        for(int j = 0; j < n; j ++) {
            cin >> g[i][j];
            g[j][i] = g[i][j];
            gr[i].push_back(j);
            gr[j].push_back(i);
        }
    }
    cin >> a[0] >> a[1];
    cycle(maybe);
    if(mini == 99999) {
        cout << -1 << endl;
        return 0;
    }
    if(mini == 0) {
        cout << 0 << endl;
        return 0;
    }
    cout << mini << endl;
    while(izh.size() != 1) {
        cout << izh.top().first << " " << izh.top().second << " ";
        izh.pop();
    }
    cout << izh.top().first << " " << izh.top().second << endl;
    return 0;
}
